//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//   FSConnect SDK
//   Copyright  2003 Russel Dirks.  All rights reserved.
//   Email : russdirks@yahoo.ca
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// these are commands sent to FSConnect using SendMessage
#define GETVAR					1
#define GETSTRING				2
#define GETPBIN				3  // not implemented
#define SETVAR					6  // only Lat/Lon supported at this time, and only works pre FS9
#define MEMREAD				4
#define MEMWRITE				5
#define SEARCHMEMRNG			8
#define SEARCHMEMALL			9
#define GETVERSIONS			10
#define GETXMLVAR				14
#define TRIGGERKEY			15


#define WM_FSCONNECT	"WM_FSCONNECT"
#define FSC_Class		"FSCONNECT8"
#define MaxAtomStr	255

// error messages used in this code
#define errNoFSC		1       // unable to communicate with FSConnect

// error messages returned by FSConnect.dll
#define errNoFSWnd			4	// couldn't find FS (not used)
#define errRegWndClass		5	// an error occurred registering the FSConnect window class
#define errCreateWnd			6	// an error occurred creating the FSConnect window
#define errNotImplemented	7	// command not implemented
#define errInvalidData		8	// FSConnect was passed invalid command data
#define errException			9	// the read/write operation you requested generated an access violation
#define errNotFound			11	// the data you were searching for was not found
#define errFSClosing			16	// FS is closing


int fscGetLatitude(double *pLat);
int fscGetLongitude(double * pLon);
int fscSetLatitude(double Lat);
int fscSetLongitude(double Lon);
int fscGetVar(GAUGE_TOKEN Token, UNIVERSAL_VAR *UVar, VAR_TYPE *VarType);
int fscGetString(GAUGE_TOKEN Token, char *pStr);
int fscSetVar(GAUGE_TOKEN Token, char *pVarData);
int fscGetVersions(char *FSCVersion, char *FSExeName, UINT *FSVerHi, UINT *FSVerLo);
int fscMemRead(PVOID addr, int nBytes, LPSTR pszMem);
int fscMemWrite(PVOID Addr, LPSTR pszData);
int fscSearchMemRange(PVOID StartAddr, PVOID EndAddr, LPCSTR SrchData, PVOID *FoundAt);
int fscSearchMemAll(LPCSTR SrchData, LPCSTR ResultsFile);
int fscTriggerKeyEvent(UINT event_id, UINT value);
int fscGetXMLVar(PCHAR szXML_Expr, double* fvalue, int* ivalue, char* svalue);



