//----------------------------------------------------------------------------
//		- Author : Rudolf Schider  (www.schider.com)
//
//    - Modifications and additions : Russel Dirks
//----------------------------------------------------------------------------

unit DemoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    Timer1: TTimer;
    Edit4: TEdit;
    Edit5: TEdit;
    Label2: TLabel;
    Edit6: TEdit;
    Label3: TLabel;
    Edit7: TEdit;
    Label4: TLabel;
    Edit8: TEdit;
    Label5: TLabel;
    Edit9: TEdit;
    Label6: TLabel;
    Edit10: TEdit;
    Label7: TLabel;
    Edit11: TEdit;
    Label8: TLabel;
    Edit12: TEdit;
    Button1: TButton;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FSCVersion : string;
    FSExeName : string;
    FSVerHi : cardinal;
    FSVerLo : cardinal;
    function DegToStr (deg : double) : string;
    procedure UpdateAll;
  end;

var
  Form2: TForm2;

implementation

uses
  Tokens,
  FSConnect;

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
begin
  if fscGetVersions(FSCVersion, FSExeName, FSVerHi, FSVerLo) = 0 then begin
    Edit1.Text := 'FSConnect Version: ' + FSCVersion;
    Edit2.Text := 'FS Version: ' +
                      IntToStr (FSVerHi div $10000) + '.' +
                      IntToStr (FSVerHi and $FFFF) + '.' +
                      IntToStr (FSVerLo div $10000) + '.' +
                      IntToStr (FSVerLo and $FFFF);
    Edit3.Text := 'FS filename: ' + FSExeName;
    UpdateAll;
  end else
    ShowMessage ('FSConnect not running.');
end;

function TForm2.DegToStr (deg : double) : string;
var
  gr : integer;
  mn : double;
begin
  gr := trunc (deg);
  mn := abs ((deg - trunc (deg)) * 60);
  result := Format ('%d%2.6f''', [gr, mn]);
end;

//.............................................................................

function IIf(b : boolean; v1 : variant; v2 : variant) : variant;
begin
	if b then
  	result := v1
  else
  	result := v2;
end;

procedure TForm2.UpdateAll;
var
  v : variant;
  s : string;
  fvalue : double;
  ivalue, res : integer;
begin
	fscGetLatitude(fvalue);
  Edit4.Text :=  DegToStr(fvalue);
  fscGetLongitude(fvalue);
  Edit5.Text :=  DegToStr(fvalue);
  fscGetVar (PLANE_ALTITUDE, vtDouble, v);
  Edit6.Text :=  FloatToStr (v * 3.2808);
  fscGetVar (AVIONICS_MASTER_SWITCH, vtBoolean, v);
  Edit7.Text :=  IIf(v, 'On', 'Off');
  fscGetVar (COM_STBY_FREQUENCY, vtBCD, v);
  Edit8.Text :=  '1' + copy(v, 1, 2) + '.' + copy(v, 3, 2);
  fscGetVar (TRANSPONDER_CODE, vtOctal, v);
  Edit9.Text :=  v;
  // for the next one, set Nav1 to a nearby vor and this will give you
  // the 3 letter identifier
  fscGetString(VOR1_IDENTITY, s);
  Edit10.Text :=  s;
  res := fscGetXMLVar('(A:TITLE,string)', fvalue, ivalue, s);
  Edit11.Text := 'User Aircraft : ' + s;
  res := fscGetXMLVar('(A:AIRSPEED INDICATED,knots)', fvalue, ivalue, s);
  Edit12.Text := FloatToStr(fvalue);

end;

procedure TForm2.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then
    FormStyle := fsStayOnTop
  else
    FormStyle := fsNormal;
end;

procedure TForm2.CheckBox1Click(Sender: TObject);
begin
  Timer1.Enabled := CheckBox1.Checked;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
	UpdateAll;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
   // set throttle to about 50%
   fscTriggerKeyEvent(KEY_THROTTLE_SET, 8000);
   // set transponder to 1234
   fscTriggerKeyEvent(KEY_XPNDR_SET, $00001234);

end;

end.
