// converted from the Panel SDK
#pragma pack(1)

// Flightsim calling convention
#define	FSAPI	__stdcall

//
// Common Flight Simulator Constant Definitions
//
#define         VERSION_MAJOR           1
#define         VERSION_MINOR           0
#define         VERSION_BUILD           0

// magic to get the preprocessor to do what we want
#define		lita(arg) #arg
#define		xlita(arg) lita(arg)
#define		cat3(w,x,z) w##.##x##.##z##\000
#define		xcat3(w,x,z) cat3(w,x,z)
#define		VERSION_STRING xlita(xcat3(VERSION_MAJOR,VERSION_MINOR,VERSION_BUILD))

#ifndef		VS_VERSION_INFO
#define		VS_VERSION_INFO		0x0001
#endif

typedef	VOID			*PVOID;
typedef	PVOID			*PPVOID;

#define	HINSTANCE	PVOID


//
// Common Flight Simulator Constant Definitions
//

// parameter direction tags
#ifndef IN
#define IN
#endif

#ifndef OUT
#define OUT
#endif

#ifndef VOID
#define VOID	void
#endif

// Logical True/False Constants
#ifndef FALSE
#define FALSE	0
#endif

#ifndef TRUE
#define TRUE	1
#endif

// Pointer Constant
#ifndef	NULL
#define NULL	((void *)0)			// empty handle
#endif

// Misc Constants
#define NULLPTR	NULL				// empty pointer
#define CR		0x0d				// ASCII carriage return
#define LF		0x0a				// ASCII line feed
#define FLAGS0	0					// no flags set in a FLAGSn type variable
#define FLAGS1	-1					// all flags set in a FLAGSn type variable

// Bit Flag Constants
#define BIT0	0x00000001
#define BIT1	0x00000002
#define BIT2	0x00000004
#define BIT3	0x00000008
#define BIT4	0x00000010
#define BIT5	0x00000020
#define BIT6	0x00000040
#define BIT7	0x00000080
#define BIT8	0x00000100
#define BIT9	0x00000200
#define BIT10	0x00000400
#define BIT11	0x00000800
#define BIT12	0x00001000
#define BIT13	0x00002000
#define BIT14	0x00004000
#define BIT15	0x00008000
#define BIT16	0x00010000
#define BIT17	0x00020000
#define BIT18	0x00040000
#define BIT19	0x00080000
#define BIT20	0x00100000
#define BIT21	0x00200000
#define BIT22	0x00400000
#define BIT23	0x00800000
#define BIT24	0x01000000
#define BIT25	0x02000000
#define BIT26	0x04000000
#define BIT27	0x08000000
#define BIT28	0x10000000
#define BIT29	0x20000000
#define BIT30	0x40000000
#define BIT31	0x80000000

// integer data types limits
#define UINT8_MIN	0
#define UINT8_MAX	255
#define SINT8_MIN	-128
#define SINT8_MAX	 127
#define UINT16_MIN	0
#define UINT16_MAX	65535
#define SINT16_MIN	-32768
#define SINT16_MAX	32767
#define UINT32_MIN	0
#define UINT32_MAX	4294967295
#define SINT32_MIN	((signed int) BIT31)
#define SINT32_MAX	2147483647

// fractional data types limits
#define UFRAC8_MIN	0
#define UFRAC8_MAX	255
#define SFRAC8_MIN	-128
#define SFRAC8_MAX	127
#define UFRAC16_MIN	0
#define UFRAC16_MAX	65535
#define SFRAC16_MIN	-32768
#define SFRAC16_MAX	32767
#define UFRAC32_MIN	0
#define UFRAC32_MAX	4294967295
#define SFRAC32_MIN	-2147483648
#define SFRAC32_MAX	2147483647

// flag values for engine_control_select variable
#define ENGINE_CONTROL_SELECT_NONE	0		// no engines
#define ENGINE_CONTROL_SELECT_1		BIT0	// engine 1
#define ENGINE_CONTROL_SELECT_2		BIT1	// engine 2
#define ENGINE_CONTROL_SELECT_3		BIT2	// engine 3
#define ENGINE_CONTROL_SELECT_4		BIT3	// engine 4

// enum values for prop_adv_sel variable
#define PROP_ADV_SEL_FIXED			0		// fixed pitch propeller
#define PROP_ADV_SEL_AUTO			1		// variable pitch propeller, automatic
#define PROP_ADV_SEL_MANUAL			2		// variable pitch propeller, manual

// realism_systems values
#define	REALISM_SYSTEMS_ELEV_TRIM	BIT1	// enable elevator trim realism (ratchet effect)
#define	REALISM_SYSTEMS_GYRO_DRIFT	BIT2	// enable gyro drift
#define	REALISM_SYSTEMS_LIGHT_BURN	BIT3	// enable light burnout if on too long during day
#define	REALISM_SYSTEMS_FAST_THROT	BIT4	// enable fast throttle kill engine
#define	REALISM_SYSTEMS_INS_LIGHTS	BIT5	// enable instrument light needed at night to see panel
#define	REALISM_SYSTEMS_BARO_DRIFT	BIT6	// enable barometric pressure drift


// defines for window layer numbers & shared buffer numbers
#define LOWEST_LAYER        0x0000
#define VIEW_LAYER          0x2000
#define MINICONTROL_LAYER   0x3000
#define PANEL_LAYER         0x4000
#define MESSAGE_LAYER       0x5000
#define HIGHEST_LAYER       0xffff


// constants for the range of the UNIPIX coordinate system
#define UNIPIX_MAX_HEIGHT   6144    // max height of unipix region
#define UNIPIX_MAX_WIDTH    8192    // max width of unipix region


// vor1_tf_flag and vor2_tf_flag
#define	VOR_TF_FLAG_OFF			0
#define	VOR_TF_FLAG_TO			1
#define	VOR_TF_FLAG_FROM		2

// Back course flags for VOR gauges
#define	BC_FLAG_BACKCOURSE_AVAILABLE	BIT0
#define	BC_FLAG_LOCALIZER_TUNED_IN		BIT1
#define	BC_FLAG_ON_BACKCOURSE			BIT2
#define	BC_FLAG_STATION_ACTIVE			BIT7

// sim_speed constants
#define	SIM_SPEED_QUARTER	0x0040
#define	SIM_SPEED_HALF		0x0080
#define	SIM_SPEED_1X		0x0100
#define	SIM_SPEED_2X		0x0200
#define	SIM_SPEED_4X		0x0400
#define	SIM_SPEED_8X		0x0800
#define	SIM_SPEED_16X		0x1000
#define	SIM_SPEED_32X		0x2000
#define	SIM_SPEED_64X		0x4000
#define	SIM_SPEED_128X		0x8000

#define	SIM_SPEED_MIN		SIM_SPEED_QUARTER
#define	SIM_SPEED_MAX		SIM_SPEED_128X

// controls limits
#define	SPOILERS_POS_OFF			0		// spoilers desired position {0=retracted..16k=fully extended}
#define	SPOILERS_POS_FULL			16383
#define	FLAPS_POS_OFF				0		// 0=up, 16383 = full
#define	FLAPS_POS_FULL				16383
#define	GEAR_POS_UP					0		// 0 = up, 16K = dn
#define	GEAR_POS_DOWN				16383

// defines for VOR_INFO.CODE field
#define	VOR_CODE_IS_LOCALIZER			BIT7	// bit7 = 0= VOR  1= Localizer
#define	VOR_CODE_GLIDESLOPE			    BIT6	// bit6 = 1= Glideslope Available
#define	VOR_CODE_BACKCOURSE_UNAVAIL	    BIT5	// bit5 = 1= no localizer backcourse
#define	VOR_CODE_DME_AT_GLIDE_SLOPE	    BIT4	// bit4 = 1= DME transmitter at Glide Slope Transmitter
#define	VOR_CODE_NAV_UNAVAILABLE	    BIT3	// bit3 = 1= no nav signal available
#define	VOR_CODE_VOICE_AVAILABLE	    BIT2	// bit2 = Voice Available
#define	VOR_CODE_TACAN				    BIT1	// bit1 = TACAN
#define VOR_CODE_DME_AVAILABLE		    BIT0	// bit0 = DME

// defines for engine structure starter variable, note:  magnetos for recip. engines / starters for jet engines
#define ENG_STARTER_MAGNETO_OFF		0	// the following values for reciprocating engines
#define ENG_STARTER_MAGNETO_RIGHT	1
#define ENG_STARTER_MAGNETO_LEFT	2
#define ENG_STARTER_MAGNETO_BOTH	3
#define ENG_STARTER_MAGNETO_START	4
#define ENG_STARTER_STARTER_OFF		0	// the following values for jet engines
#define ENG_STARTER_STARTER_START	1
#define ENG_STARTER_STARTER_GEN		2


#define GST_UNUSED  0x0000
#define GST_ACTIVE  0x0001
#define GST_GEAR    0x0002
#define GST_SCRAPE  0x0004

#define GSN_CENTER_GEAR         0
#define GSN_LEFT_GEAR           1
#define GSN_RIGHT_GEAR          2
#define GSN_AUX_GEAR            3
#define GSN_RIGHT_WING_SCRAPE   4
#define GSN_LEFT_WING_SCRAPE    5
#define GSN_FUSELAGE_SCRAPE     6
#define GSN_XTAIL_SCRAPE        7
#define GSN_AUX1_SCRAPE         8
#define GSN_AUX2_SCRAPE         9

#define TANK_MAIN_RIGHT     0
#define TANK_MAIN_LEFT      1
#define TANK_AUX_RIGHT      2
#define TANK_AUX_LEFT       3
#define TANK_TIP_RIGHT      4
#define TANK_TIP_LEFT       5
#define TANK_CENTER         6
#define TANK_CENTER2        7
#define TANK_CENTER3        8
#define TANK_EXTERNAL1      9
#define TANK_EXTERNAL2      10

// gear types
#define GEAR_TYPE_FIXED         0
#define GEAR_TYPE_RETRACTABLE   1
#define GEAR_TYPE_SKIDS         2
#define GEAR_TYPE_FLOATS        3
#define GEAR_TYPE_SKIS          4


// time_of_day constants
#define TIME_OF_DAY_DAY     BIT0
#define TIME_OF_DAY_DAWN    BIT1
#define TIME_OF_DAY_DUSK    BIT1
#define TIME_OF_DAY_NIGHT   BIT2

// surface_type constants
typedef enum SURFACE_TYPE
{
    SURFACE_TYPE_CONCRETE       = 0,    // concrete
    SURFACE_TYPE_GRASS          = 1,    // soft, bumpy ground (landable)
    SURFACE_TYPE_WATER          = 2,    // water
    SURFACE_TYPE_GRASS_BUMPY    = 3,    // very bumpy grass & mud (crashable)
    SURFACE_TYPE_ASPHALT        = 4,    // asphalt
    SURFACE_TYPE_SHORT_GRASS    = 5,    // short grass
    SURFACE_TYPE_LONG_GRASS     = 6,    // long grass
    SURFACE_TYPE_HARD_TURF      = 7,    // hard turf
    SURFACE_TYPE_SNOW           = 8,
    SURFACE_TYPE_ICE            = 9,
    SURFACE_TYPE_URBAN          = 10,
    SURFACE_TYPE_FOREST         = 11,
    SURFACE_TYPE_DIRT           = 12,   // added for dirt runways
    SURFACE_TYPE_CORAL          = 13,   // added for coral runways
    SURFACE_TYPE_GRAVEL         = 14,   // added for gravel runways
    SURFACE_TYPE_OIL_TREATED    = 15,   // added for oil treated (tar&chip) runways
    SURFACE_TYPE_STEEL_MATS     = 16,   // added for steel mats (steel mesh) temporary runways
    SURFACE_TYPE_BITUMINUS		= 17,
    SURFACE_TYPE_BRICK          = 18,
    SURFACE_TYPE_MACADAM        = 19,
    SURFACE_TYPE_PLANKS         = 20,
    SURFACE_TYPE_SAND		    = 21,
    SURFACE_TYPE_SHALE		    = 22,
    SURFACE_TYPE_TARMAC		    = 23,

    SURFACE_TYPE_UNKNOWN        = 254,  // valid but unknown surface type
    SURFACE_TYPE_UNDEFINED      = 255   // invalid surface type
}
SURFACE_TYPE, *PSURFACE_TYPE;

typedef enum SURFACE_CONDITION
{
    SURFACE_CONDITION_NORMAL    = 0,    // default for the given SURFACE_TYPE
    SURFACE_CONDITION_WET,
    SURFACE_CONDITION_ICY,
    SURFACE_CONDITION_SNOW,             // this is for snow on a non-snow SURFACE_TYPE
    SURFACE_CONDITION_MAX       // this surface condition should always be last
}
SURFACE_CONDITION;

#define PDDF_ALTITUDE           BIT0            // Altitude hold turned on
#define PDDF_VELOCITY_ALTITUDE  BIT1            // Vertical speed hold turned on (or alt)
#define PDDF_PITCH              BIT2            // Pitch hold turned on (or vs or alt)
#define PDDF_BANK               BIT3            // Bank hold turned on (or heading)
#define PDDF_HEADING            BIT4            // Heading hold turned on
#define PDDF_ROLL_RATE          BIT5            // Roll rate hold turned on
#define PDDF_BODY_PITCH_VEL     BIT6            // Body pitch velocity turned on
#define PDDF_AIRSPEED           BIT7            // Airspeed hold turned on
#define PDDF_GROUNDSPEED        BIT8            // Groundspeed hold
#define PDDF_POSITION           BIT9            // Ground position hold or formation flight position hold
#define PDDF_GROUND_VEL_DIR     BIT10           // Additional flag to heading control - ground velocity direction hold


#define AUTOPILOT_ALL_ALTITUDE_FLAGS (PDDF_ALTITUDE | PDDF_VELOCITY_ALTITUDE | PDDF_PITCH | PDDF_BODY_PITCH_VEL)
#define AUTOPILOT_ALL_HEADING_FLAGS  (PDDF_HEADING | PDDF_BANK | PDDF_ROLL_RATE | PDDF_POSITION)

#define AUTOPILOT_ENABLE_ALTITUDE_HOLD  (PDDF_ALTITUDE | PDDF_VELOCITY_ALTITUDE | PDDF_PITCH)
#define AUTOPILOT_ENABLE_PITCH_HOLD     (PDDF_PITCH)
#define AUTOPILOT_ENABLE_BODY_PITCH_VEL_HOLD    (PDDF_BODY_PITCH_VEL)
#define AUTOPILOT_ENABLE_HEADING_HOLD   (PDDF_HEADING | PDDF_BANK)
#define AUTOPILOT_ENABLE_BANK_HOLD      (PDDF_BANK)
#define AUTOPILOT_ENABLE_ROLL_RATE_HOLD (PDDF_ROLL_RATE)
#define AUTOPILOT_ENABLE_POSITION_HOLD  (PDDF_POSITION | PDDF_HEADING)



#define FS_REG_BASE     "SOFTWARE\\Microsoft\\Microsoft Games\\Flight Simulator\\8.0"

enum TOOLTIP_UNITS_TYPE {
    TOOLTIP_UNITS_TYPE_DEFAULT,
    TOOLTIP_UNITS_TYPE_METRIC,
    TOOLTIP_UNITS_TYPE_US,
};



//
// Common Flight Simulator Data Types
//

typedef void            *PVOID;
typedef PVOID           *PPVOID;

typedef unsigned    char    UINT8, *PUINT8, **PPUINT8;
typedef signed      char    SINT8, *PSINT8, **PPSINT8;
typedef unsigned    short   UINT16, *PUINT16, **PPUINT16;
typedef signed      short   SINT16, *PSINT16, **PPSINT16;
typedef signed      int     SINT32, *PSINT32, **PPSINT32;
typedef unsigned    char    VAR8, *PVAR8, **PPVAR8;
typedef unsigned    short   VAR16, *PVAR16, **PPVAR16;
typedef unsigned    int     VAR32, *PVAR32, **PPVAR32;

#ifndef _BASETSD_H_
typedef unsigned    int     UINT32, *PUINT32;
#endif
typedef unsigned    int     **PPUINT32;


#ifndef _BASETSD_H_ 
typedef unsigned __int64 UINT64, *PUINT64, **PPUINT64;
#endif

typedef signed __int64 SINT64, *PSINT64, **PPSINT64;

// 64-bit generic structure
typedef struct  VAR64
{
    VAR32   lo;
    VAR32   hi;
} VAR64, *PVAR64, **PPVAR64;

typedef struct  UIF64
{
    UINT32  f;
    UINT32  i;
} UIF64, *PUIF4, **PPUIF64;

typedef struct  SVAR64
{
    UINT32  lo;
    SINT32  hi;
} SVAR64, *PSVAR64, **PPSVAR64;

// boolean variables - hold TRUE/FALSE
typedef int     BOOL, *PBOOL, **PPBOOL;
typedef VAR8    BOOL8, *PBOOL8, **PPBOOL8;
typedef VAR16   BOOL16, *PBOOL16, **PPBOOL16;
typedef VAR32   BOOL32, *PBOOL32, **PPBOOL32;

// array of 1-bit boolean variables
typedef int     FLAGS, *PFLAGS, **PPFLAGS;
typedef VAR8    FLAGS8, *PFLAGS8, **PPFLAGS8;
typedef VAR16   FLAGS16, *PFLAGS16, **PPFLAGS16;
typedef VAR32   FLAGS32, *PFLAGS32, **PPFLAGS32;

// Enumeration variables - domain is subset of all possible values
typedef int     ENUM, *PENUM, **PPENUM;
typedef VAR8    ENUM8, *PENUM8, **PPENUM8;
typedef VAR16   ENUM16, *PENUM16, **PPENUM16;
typedef VAR32   ENUM32, *PENUM32, **PPENUM32;

// array index variables
typedef int     INDX, *PINDX, **PPINDX;
typedef VAR8    INDX8, *PINDX8, **PPINDX8;
typedef VAR16   INDX16, *PINDX16, **PPINDX16;
typedef VAR32   INDX32, *PINDX32, **PPINDX32;

// Identifier variables
typedef int     ID, *PID, **PPID;
typedef VAR8    ID8, *PID8, **PPID8;
typedef VAR16   ID16, *PID16, **PPID16;
typedef VAR32   ID32, *PID32, **PPID32;

// Error return variables
typedef VAR32   ERR, *PERR, **PPERR;

// Fractional variables
typedef UINT8   UFRAC8, *PUFRAC8, **PPUFRAC8;    // { 0..+1}
typedef SINT8   SFRAC8, *PSFRAC8, **PPSFRAC8;    // {-1..+1}
typedef UINT16  UFRAC16, *PUFRAC16, **PPUFRAC16; // { 0..+1}
typedef SINT16  SFRAC16, *PSFRAC16, **PPSFRAC16; // {-1..+1}
typedef UINT32  UFRAC32, *PUFRAC32, **PPUFRAC32; // { 0..+1}
typedef SINT32  SFRAC32, *PSFRAC32, **PPSFRAC32; // {-1..+1}

// Floating-point types
typedef double  FLOAT64, *PFLOAT64, **PPFLOAT64;
typedef float   FLOAT32, *PFLOAT32, **PPFLOAT32;

// Integer/Fraction structures both signed & unsigned
typedef UINT16  UIF16, *PUIF16, **PPUIF16;

typedef SINT16  SIF16, *PSIF16, **PPSIF16;

typedef UINT32  UIF32, *PUIF32, **PPUIF32;

typedef SINT32  SIF32, *PSIF32, **PPSIF32;

#ifdef _H2INC
typedef struct  UIF48
{
    UINT16  pad;
    UINT16  f;
    UINT32  i;
} UIF48, *PUIF48, **PPUIF48;

typedef struct  SIF48
{
    UINT16  pad;
    UINT16  f;
    SINT32  i;
} SIF48, *PSIF48, **PPSIF48;
#else
typedef union   UIF48
{
    struct
    {
        UINT16  pad;
        UINT16  f;
        UINT32  i;
    };

    UINT64      i64;

} UIF48, *PUIF48, **PPUIF48;

typedef union   SIF48
{
    struct
    {
        UINT16  pad;
        UINT16  f;
        SINT32  i;
    };

    SINT64      i64;

} SIF48, *PSIF48, **PPSIF48;
#endif


typedef SVAR64  SIF64, *PSIF64, **PPSIF64;

#if !defined(_WINNT_)               // NOT PORTABLE!
typedef char    CHAR;
typedef char    *PCHAR;             // single character
#endif
typedef PCHAR   *PPCHAR;            // pointer to pointer to char
typedef CHAR    STRING, *PSTRING, **PPSTRING;       // generic string of unknown length
typedef CHAR    STRINGZ, *PSTRINGZ, **PPSTRINGZ;    // generic string of unknown length, zero term
typedef const CHAR  *PCSTRINGZ, **PPCSTRINGZ;   // generic string of unknown length, zero term

typedef struct SUBSTRING
{
    PSTRINGZ    string;
    UINT32      leng;
}   SUBSTRING, *PSUBSTRING, **PPSUBSTRING;

typedef VAR16   BCD16, *PBCD16, **PPBCD16;      // 4-digit BCD number (0000-9999)
typedef VAR16   BCO16, *PBCO16, **PPBCO16;      // 4-digit Octal number (0000-7777) (in BCD)
typedef VAR32   BCD32, *PBCD32, **PPBCD32;      // 8-digit BCD number (00000000-99999999)
typedef VAR32   BCO32, *PBCO32, **PPBCO32;      // 8-digit Octal number (00000000-77777777) (in BCD)

// pseudodegree variables
typedef VAR8    ANGL8, *PANGL8, **PPANGL8;
typedef VAR16   ANGL16, *PANGL16, **PPANGL16;
typedef VAR32   ANGL32, *PANGL32, **PPANGL32;
#ifdef _H2INC
typedef struct  ANGL48
{
    UINT16  pad;
    UINT16  lo;
    UINT32  hi;
} ANGL48, *PANGL48, **PPANGL48;
#else
typedef union   ANGL48
{
    struct
    {
        UINT16  pad;
        UINT16  lo;
        UINT32  hi;
    };

    UINT64      i64;

} ANGL48, *PANGL48, **PPANGL48;
#endif

typedef ANGL48  SINT48, *PSINT48, **PPSINT48;

// radians
typedef FLOAT64 RADIANS;

// counter variables
typedef VAR8    CNTR8, *PCNTR8, **PPCNTR8;
typedef VAR16   CNTR16, *PCNTR16, **PPCNTR16;
typedef VAR32   CNTR32, *PCNTR32, **PPCNTR32;

// ring counter variables - modified by shifting instead of add/sub
typedef VAR8    RCNTR8, *PRCNTR8, **PPRCNTR8;
typedef VAR16   RCNTR16, *PRCNTR16, **PPRCNTR16;
typedef VAR32   RCNTR32, *PRCNTR32, **PPRCNTR32;

// Spare/Unused variables
typedef VAR8    SPARE8;
typedef VAR16   SPARE16;
typedef VAR32   SPARE32;

// version number data type
typedef struct  APP_VERSION
{
    UINT32  major;
    UINT32  minor;
    UINT32  build;
} APP_VERSION, *PAPP_VERSION, **PPAPP_VERSION;

// LatLon - used to store a position in 2D space
typedef struct
{
    SIF48       lat;
    ANGL48      lon;
} LATLON, *PLATLON, **PPLATLON;

// LatLon32 - used to store a position in 2D space (less accuracy)
typedef struct
{
    SINT32      lat;
    ANGL32      lon;
} LATLON32, *PLATLON32, **PPLATLON32;

// LatLonAlt - used to store a position in 3D space
typedef struct  LATLONALT
{
    SIF48       lat;
    ANGL48      lon;
    SIF48       alt;
} LATLONALT, *PLATLONALT, **PPLATLONALT;

typedef struct
{
    SINT32      lat;                // 32 bits of LAT (Meters)
    ANGL32      lon;                // 32 bits of LON
    SINT32      alt;                // 32 bits of ALT (Meters)
} LATLONALT32, *PLATLONALT32, **PPLATLONALT32;

typedef struct  _latlonalt_float32
{
    FLOAT32     lat;
    FLOAT32     lon;
    FLOAT32     alt;
} LATLONALT_FLOAT32, *PLATLONALT_FLOAT32, **PPLATLONALT_FLOAT32;

typedef struct _llf64               // llf64
{
    FLOAT64     lat;                // degrees (+/-90)
    FLOAT64     lon;                // degrees (+/-180)
} LLF64, *PLLF64, **PPLLF64;

typedef struct _llaf64              // llaf64
{
    FLOAT64     lat;                // degrees (+/-90)
    FLOAT64     lon;                // degrees (+/-180)
    FLOAT64     alt;                // meters (+/- a lot)
} LLAF64, *PLLAF64, **PPLLAF64;

// ZXY48 - used to mirror LatLonAlt with Lon as meters IIII.FF
typedef struct  ZXY48
{
    SIF48       z;
    SIF48       x;
    SIF48       y;
} ZXY48, *PZXY48, **PPZXY48;




// FLOAT64_VECTOR3 - <i,j,k> vector, hopefully normalized
typedef struct  _FLOAT64_VECTOR3
{
    FLOAT64     i ;
    FLOAT64     j ;
    FLOAT64     k ;
}   FLOAT64_VECTOR3, *PFLOAT64_VECTOR3 ;

// FLOAT64_VECTOR2 - <i,j> vector
typedef struct  _FLOAT64_VECTOR2
{
    FLOAT64     i ;
    FLOAT64     j ;
}   FLOAT64_VECTOR2, *PFLOAT64_VECTOR2 ;

// PBH32 & PBH16 - rotation parameters of an object

typedef struct  PBH32
{
    ANGL32  pitch;
    ANGL32  bank;
    ANGL32  heading;
} PBH32, *PPBH32, **PPPBH32;

typedef struct  PBH16
{
    ANGL16  pitch;
    ANGL16  bank;
    ANGL16  heading;
} PBH16, *PPBH16, **PPPBH16;


// LATLONBOX - a set of lat and lon values that defines a rectangular boundary
typedef struct LATLONBOX
{
    SIF48   top;
    ANGL48  left;
    SIF48   bottom;
    ANGL48  right;
} LATLONBOX, *PLATLONBOX, **PPLATLONBOX;

// LATLONRECT32 - a set of lat and lon values that defines a rectangular boundary
typedef struct LATLONRECT32
{
    SINT32  north;
    SINT32  south;
    ANGL32  east;
    ANGL32  west;
} LATLONRECT32, *PLATLONRECT32, **PPLATLONRECT32;

// LATLONRECT32 - a set of lat and lon values that defines a rectangular boundary
typedef struct LATLONRECTF64
{
    FLOAT64 north;
    FLOAT64 south;
    FLOAT64 east;
    FLOAT64 west;
} LATLONRECTF64, *PLATLONRECTF64, **PPLATLONRECTF64;

typedef struct LLAPBH
{
    LATLONALT   lla;
    PBH32       pbh;
}  LLAPBH, *PLLAPBH, **PPLLAPBH;

// LATLONALTPBH - Combination of LATLONALT & PBH32
typedef union LATLONALTPBH
{
    struct
    {
        SIF48       lat;
        ANGL48      lon;
        SIF48       alt;
        ANGL32      pitch;
        ANGL32      bank;
        ANGL32      heading;
    };

    struct
    {
        LATLONALT   lla;
        PBH32       pbh;
    };
} LATLONALTPBH, *PLATLONALTPBH, **PPLATLONALTPBH;

// LATLONALTTPO - Time, Position, Orientation using LatLonAlt for Position
typedef struct  LATLONALTTPO
{
    UINT32      time;

    union
    {
        struct
        {
            SIF48       lat;
            ANGL48      lon;
            SIF48       alt;
            ANGL32      pitch;
            ANGL32      bank;
            ANGL32      heading;
        };

        struct
        {
            LATLONALT   lla;
            PBH32       pbh;
        };

        LATLONALTPBH    llapbh;
    };
} LATLONALTTPO, *PLATLONALTTPO, **PPLATLONALTTPO;

// Data structures for BGL manipulation
typedef struct LLA2416
{
    char    stream[3+3+2];
} LLA2416, *PLLA2416, **PPLLA2416;

typedef struct LLA2424
{
    char    stream[3+3+3];
} LLA2424, *PLLA2424, **PPLLA2424;

// coordinates of a point in a cartesion system
typedef struct  XYZ16
{
    SINT16  x;
    SINT16  y;
    SINT16  z;
} XYZ16, *PXYZ16, **PPXYZ16;

typedef struct  XYZ32
{
    SINT32  x;
    SINT32  y;
    SINT32  z;
} XYZ32, *PXYZ32, **PPXYZ32;

typedef struct  _xyz_float32
{
    FLOAT32     x;
    FLOAT32     y;
    FLOAT32     z;
} XYZ_FLOAT32, *PXYZ_FLOAT32, **PPXYZ_FLOAT32;


// Same as above, but uses east, altit, north for field names
typedef struct  EAN32
{
    SINT32  east;
    SINT32  altit;
    SINT32  north;
} EAN32, *PEAN32, **PPEAN32;

// Coordinates of a point on the XZ plane

typedef struct  XZF32
{
    FLOAT32 x;
    FLOAT32 z;
} XZF32, *PXZF32, **PPXZF32;

typedef struct  XZ32
{
    SINT32  x;
    SINT32  z;
} XZ32, *PXZ32, **PPXZ32;

// same as above, but uses east, north for field names

typedef struct  EN32
{
    SINT32  east;
    SINT32  north;
} EN32, *PEN32, **PPEN32;

// ANGLSINCOS16 structure to hold data for an angle and it's trig functions
typedef struct  ANGLSINCOS16
{
    ANGL16  angle;
    SFRAC16 sine;
    SFRAC16 cosine;
} ANGLSINCOS16, *PANGLSINCOS16, **PPANGLSINCOS16;

// XYZPBH - defines the position of an object
typedef union   XYZPBH
{
    struct
    {
        SINT32  x;
        SINT32  y;
        SINT32  z;
        ANGL16  pitch;
        ANGL16  bank;
        ANGL16  heading;
    };

    struct
    {
        XYZ32   xyz;
        PBH16   pbh;
    };
} XYZPBH, *PXYZPBH, **PPXYZPBH;

// XYZTPO - same as above, but starts with a time-stamp field
// Notes: these structures will need to be reordered when
//  H2INc is fixed!
typedef struct  XYZTPO
{
    UINT32  time;

    union
    {
        struct
        {
            SINT32  x;
            SINT32  y;
            SINT32  z;
            ANGL16  pitch;
            ANGL16  bank;
            ANGL16  heading;
        };

        struct
        {
            XYZ32   xyz;
            PBH16   pbh;
        };

        XYZPBH  xyzpbh;
    };
} XYZTPO, *PXYZTPO, **PPXYZTPO;


// XYZF64_  - XYZ point(vector) in floating point
// XYZF64 - XYZ vector which includes XYZF64 as a part of union
// (needed to be changed together with XYZF64)

struct  XYZF64_
{
    FLOAT64 x;
    FLOAT64 y;
    FLOAT64 z;
};

//  XYZF64, *PXYZF64, **PPXYZF64;

typedef struct  XYZF64
{
    union
    {
        struct { FLOAT64   lon; FLOAT64 alt;      FLOAT64 lat; };
        struct { FLOAT64     x; FLOAT64  y;       FLOAT64   z; };
        struct { FLOAT64 pitch; FLOAT64 heading;  FLOAT64 bank;};
    };
}
XYZF64, *PXYZF64, **PPXYZF64,
POS3_FLOAT64,
VEL3_FLOAT64, *PVEL3_FLOAT64, **PPVEL3_FLOAT64,
ACC3_FLOAT64,
ROT3_FLOAT64,
ROV3_FLOAT64,
ROA3_FLOAT64;

//-----------------------------------------------


// XYF64 - XY point (vector in 2d space) in floating point
typedef struct XYF64                // xyf64
{
    FLOAT64 x;
    FLOAT64 y;
} XYF64, *PXYF64, **PPXYF64;


//----------------------------------------------------
// XYZF32 - XYZW point(vector) in floating point
typedef struct XYZF32 {
    FLOAT32 x;
    FLOAT32 y;
    FLOAT32 z;
    FLOAT32 w;
}   XYZF32, *PXYZF32;

#ifdef __cplusplus
struct CXYZF32:public XYZF32
{
    CXYZF32() { }
    CXYZF32(FLOAT32 _x, FLOAT32 _y, FLOAT32 _z, FLOAT32 _w=1.0f) {x = _x; y = _y; z = _z; w = _w;}
};
#endif
//---------------------------------------------------


typedef FLOAT64 ANGLF64;    // radians

// PBHF64 - Pitch/bank/heading in floating point radians
typedef struct PBHF64 {
    ANGLF64 pitch;
    ANGLF64 bank;
    ANGLF64 heading;
} PBHF64, *PPBHF64, **PPPBHF64;

// FLOAT32 matrix
typedef struct MATRIXF32
{
    union
    {
        struct { XYZF32 x,y,z,w;};
        struct
        {
            FLOAT32 m00, m01, m02, m03;
            FLOAT32 m10, m11, m12, m13;
            FLOAT32 m20, m21, m22, m23;
            FLOAT32 m30, m31, m32, m33;
        };
        struct
        {
            FLOAT32 _11, _12, _13, _14;
            FLOAT32 _21, _22, _23, _24;
            FLOAT32 _31, _32, _33, _34;
            FLOAT32 _41, _42, _43, _44;
        };
        FLOAT32 m[4][4];
        FLOAT32 mat[4][4];
    };
#ifdef __cplusplus
    FLOAT32& operator()(int iRow, int iColumn) { return m[iRow][iColumn]; }
    const FLOAT32& operator()(int iRow, int iColumn) const { return m[iRow][iColumn]; }
#endif
} MATRIXF32, *PMATRIXF32;

// map ROTMTRXF64 to a MATRIXF32
typedef MATRIXF32  ROTMTRXF64, *PROTMTRXF64;
// map QUATERN_ROTMAT to a MATRIXF32
typedef MATRIXF32  QUATERN_ROTMAT, *PQUATERN_ROTMAT;

//  2D data structures

typedef SINT32  UNIPIX, *PUNIPIX, **PPUNIPIX;   // universal pixel (X=0-8191    Y=0-6143}
typedef SINT32  PIXEL, *PPIXEL, **PPPIXEL;      // screen pixel
typedef VAR32  UNICOL, *PUNICOL, **PPUNICOL;    // universal color code

typedef struct  RGB15
{
    UINT16      blue:5;
    UINT16      green:5;
    UINT16      red:5;
    UINT16      alpha:1;
} RGB15, *PRGB15, **PPRGB15;

typedef struct  RGB16
{
    UINT16      blue:5;
    UINT16      green:6;
    UINT16      red:5;
} RGB16, *PRGB16, **PPRGB16;


typedef struct  RGB24
{
    UINT8       blue;
    UINT8       green;
    UINT8       red;
} RGB24, *PRGB24, **PPRGB24;

typedef struct  RGB32
{
    UINT8       blue;
    UINT8       green;
    UINT8       red;
    UINT8       junk;
} RGB32, *PRGB32, **PPRGB32;

typedef struct  RGBA
{
    UINT8       blue;
    UINT8       green;
    UINT8       red;
    UINT8       alpha;
} RGBA, *PRGBA, **PPRGBA;

typedef struct  RGB         // this is used by the 2d system and stuff
{                           // note that red and blue are backwards from
    UINT8       red;        // what windows expects
    UINT8       green;
    UINT8       blue;
} RGB, *PRGB, **PPRGB;

typedef struct  RGBAF
{
    FLOAT32     r;
    FLOAT32     g;
    FLOAT32     b;
    FLOAT32     a;
} RGBAF, *PRGBAF;

typedef struct  XY
{
    SINT32  x;
    SINT32  y;
} XY, *PXY, **PPXY;

typedef struct  UNIPOINT
{
    UNIPIX  x;
    UNIPIX  y;
} UNIPOINT, *PUNIPOINT, **PPUNIPOINT;

typedef struct  UNIBOX
{
    UNIPIX  x;
    UNIPIX  y;
    UNIPIX  size_x;
    UNIPIX  size_y;
} UNIBOX, *PUNIBOX, **PPUNIBOX;

typedef struct  UNIRECT
{
    UNIPIX  left;
    UNIPIX  top;
    UNIPIX  right;
    UNIPIX  bottom;
} UNIRECT, *PUNIRECT, **PPUNIRECT;

typedef struct  PIXPOINT
{
    PIXEL x;
    PIXEL y;
} PIXPOINT, *PPIXPOINT, **PPPIXPOINT;

typedef const PIXPOINT *PCPIXPOINT, **PPCPIXPOINT;

typedef struct  PIXBOX
{
    PIXEL x;
    PIXEL y;
    PIXEL size_x;
    PIXEL size_y;
} PIXBOX, *PPIXBOX, **PPPIXBOX;

typedef struct  PIXRECT
{
    PIXEL left;
    PIXEL top;
    PIXEL right;
    PIXEL bottom;
} PIXRECT, *PPIXRECT, **PPPIXRECT;


typedef struct  BOUNDSRECT
{
    SIF48   N;                  //  north boundary
    SIF48   S;                  //  south boundary
    ANGL48  E;                  // east boundary
    ANGL48  W;                  // west boundary

} BOUNDSRECT, *PBOUNDSRECT, **PPBOUNDSRECT;


typedef struct
{
    SINT32  north;              // north boundary
    SINT32  south;              // south boundary
    SINT32  east;               // east boundary
    SINT32  west;               // west boundary

} BOUNDSRECT32, *PBOUNDSRECT32, **PPBOUNDSRECT32;


// LLA_INFO - this struct contains a LATLONALT param and a user definable PVOID ptr
//  useful for an array of LATLONALTs that you also want to associate some additional data with
typedef struct  LLA_INFO
{
    union
    {
        struct
        {
            SIF48       lat;
            ANGL48      lon;
            SIF48       alt;
        };
        LATLONALT   lla;
    };
    PVOID               data_ptr;
} LLA_INFO, *PLLA_INFO, **PPLLA_INFO;


// enum constants for IMAGE.format
typedef enum IMG_FORMAT
{
    IMG_8_BIT_MONOCHROME = 0,
    IMG_8_BIT_INDEXED,
    IMG_15_BIT,             // 1555
    IMG_16_BIT,             // 565
    IMG_16A_BIT,            // 4444
    IMG_24_BIT,             // 888
    IMG_32_BIT,             // 888
    IMG_32A_BIT,            // 8888
    IMG_DXT1,               // DirectX Texture Compression DXT1
    IMG_DXT3,               // DirectX Texture Compression DXT3
    IMG_MAX                 // keep this last
} IMG_FORMAT, *PIMG_FORMAT, **PPIMG_FORMAT;

// IMAGE - structure containing info pertaining to an offscreen image buffer
//         NOTE this structure should not change size compared to the FS98
//         version because gauges use this structure
typedef struct  IMAGE
{
    IMG_FORMAT  format:16;  // bit format for this image
    UINT32      flags:16;   // flags for this image
    PIXPOINT    dim;        // offscreen buffer size (viewable area)
    UINT32      pitch;      // offset to add to advance one scan line in image buffer
    RGBA*       palette;    // palette for IMG_8_BIT_INDEXED images (was rowtbl)
    UINT32      len;        // xxx
    PCHAR       image;      // pointer to image buffer
    PVOID       pdx;        // pointer to directx information
} IMAGE, *PIMAGE, **PPIMAGE;

typedef const IMAGE *PCIMAGE, **PPCIMAGE;

#define IMAGE_XY(p,x,y) ((BYTE *)(p)->image + ((p)->pitch * (y)) + (x))
#define IMAGE_PTR(p,y)  IMAGE_XY(p,0,y)

// View Dir enum for select_view
typedef	enum	VIEW_DIR {
	VIEW_DIR_FORWARD,
	VIEW_DIR_FORWARD_RIGHT,
	VIEW_DIR_RIGHT,
	VIEW_DIR_REAR_RIGHT,
	VIEW_DIR_REAR,
	VIEW_DIR_REAR_LEFT,
	VIEW_DIR_LEFT,
	VIEW_DIR_FORWARD_LEFT,
	VIEW_DIR_DOWN,
	VIEW_DIR_FORWARD_UP,
	VIEW_DIR_FORWARD_RIGHT_UP,
	VIEW_DIR_RIGHT_UP,
	VIEW_DIR_REAR_RIGHT_UP,
	VIEW_DIR_REAR_UP,
	VIEW_DIR_REAR_LEFT_UP,
	VIEW_DIR_LEFT_UP,
	VIEW_DIR_FORWARD_LEFT_UP,
	VIEW_DIR_UP,
	VIEW_DIR_AUX_00,
	VIEW_DIR_AUX_01,
	VIEW_DIR_AUX_02,
	VIEW_DIR_AUX_03,
	VIEW_DIR_AUX_04,
	VIEW_DIR_AUX_05,
	VIEW_DIR_MAX
} VIEW_DIR, *PVIEW_DIR, **PPVIEW_DIR;


// BOUNDBOX - this structure is used extensively by the FrontEnd system, and by the symbolic map
typedef struct BOUNDBOX
{
    SIF32   N;      // northern latitude boundary
    SIF32   S;      // southern latitude boundary
    ANGL32  E;      // eastern longitude boundary
    ANGL32  W;      // western longitude boundary
} BOUNDBOX, *PBOUNDBOX, **PPBOUNDBOX;

typedef struct _engine_fuel_vars
{
    ENUM        tank_selector;          //what tanks are selected to draw from
    FLAGS       tanks_used;             //what tanks are actually being drawn from
    UINT32      number_of_tanks_used;   //# of tanks being drawn from
    FLOAT64     fuelflow_pph;           //lbs/hr
    BOOL32      fuel_available;         //True or False in selected tanks

} ENG_FUEL_VARS, *PENG_FUEL_VARS, **PPENG_FUEL_VARS;

typedef struct  ENG
{
    SINT16      throttle_lvr_pos;       // throttle position (0-16384=>0-100%throttle position)
    UINT16      propeller_lvr_pos;      // propeller lever position (0-16384=>0-100%prop setting)
    UINT16      mixture_lvr_pos;        // mixture position (0-16384=>0-100%mixture position)
    ENUM16      starter;                // starter switch position

    BOOL16      combustion;             // combustion flag (combustion = TRUE)
    UINT16      n1_rpm;                 // gas producer RPM (0-16384=>0-100%RPM)
    UINT16      n2_rpm;                 // power RPM (0-16384=>0-100%RPM)
    UINT16      ff_pph;                 // fuel flow (0-16384=>0-100%)PPH (normalized to Lear 3500 lbs thrust)
    UINT32      ff_pph_actual;          // fuel flow (0-16384=>0-100%)PPH
    UINT16      ff_pph_ssl;             // fuel flow (0-16384=>0-100%)PPH, Standard sea level conditions
    UINT16      torque;                 // torque produced by engine (FT*LBS)
    UINT16      absorbed_torque;        // torque absorbed by propeller (FT*LBS)
    SINT32      thrust_lbs;             // thrust (LBS)
    ANGL16      blade_angle_pdeg;       // propeller blade angle (PDEG)

    BOOL16      lf_mag;                 // left magneto status (activated = 1)
    BOOL16      rt_mag;                 // right magneto status (activated = 1)
    BOOL16      anti_ice;               // anti ice switch
    UINT16      epr_bug_pos;            // epr governed engine setting (0-16384=>0-100%epr setting)
    UINT16      egt_bug_pos;            // egt governed engine setting (0-16384=>0-100%egt setting)

    UINT16      oil_tmp;                // oil temperature (degC) * 16384
    UINT16      oil_prs;                // oil pressure (PSI) * 16384
    UINT16      epr;                    // engine pressure ratio (0-65536=>0-6.4)
    UINT16      egt_degC;               // exhaust gas temperature (degC)
    UINT16      manifold_pressure;      // manifold pressure (0-65536=>0-64)

    SINT16      x_pos;                  // lateral engine position (IN)
    SINT16      y_pos;                  // vertical engine position (IN)
    SINT16      z_pos;                  // longitudinal engine position (IN)

    UINT16      rpm_scaler;             // *16384 gives actual prop rpm in dx (= 65535 for jets)
    PVOID       ext_ptr;                // engine structure extension pointer

    UINT32      oil_quantity;           //oil quantity (0-16384 => 0-100%)
    UINT32      engine_vibration;       //oil quantity (0-16384 => 0-5)
    UINT32      hydraulic_pressure;     //hydraulic pressure (0-16384 => 0-4 psi)
    UINT32      hydraulic_quantity;     //hydraulic quantity (0-16384 => 0-100%)
    FLOAT64     induced_velocity;       //induced velocity from propwash or jet blast

    FLOAT64     cyl_head_temp_degF;     //cylinder head temperature (deg F)

    UINT32      tot_ind;                // TOT * 16384, deg C
    UINT32      torque_ind;             // TQ * 16384, %
    UINT32      Wfpress_ind;            // Fuel Pressure * 16384, psi
    UINT32      electric_load;          // electrical load * 16384, % max load
    UINT32      xmsn_pressure;          // xmsn pressure * 16384, psi
    UINT32      xmsn_temperature;       // transmission temp * 16384, deg C
    UINT32      rotor_rpm;              // main rotor speed * 16384, % max

    ENG_FUEL_VARS   fuel_vars;

} ENG, *PENG, **PPENG;


// mouse sensitivity structure
typedef struct  SENSEBLOCK
{
    PIXEL       left;
    PIXEL       top;
    PIXEL       right;
    PIXEL       bottom;
    PVOID       routine;
} SENSEBLOCK, *PSENSEBLOCK, **PPSENSEBLOCK;

// Vor transmitter type
#define VOR_UNKNOWN     0
#define VOR_TERMINAL    1
#define VOR_LOW_ALT     2
#define VOR_HIGH_ALT    3
#define VOR_ILS         4


typedef struct
{
    ENUM32      code;               // code value
    PSTRINGZ    text;               // text value
} LOOKUP_TABLE, *PLOOKUP_TABLE, **PPLOOKUP_TABLE;

typedef struct _xyz_minmax
{
    XYZF32 xyzMin;
    XYZF32 xyzMax;
} XYZ_MINMAX, *PXYZ_MINMAX, **PPXYZ_MINMAX;


typedef struct _min_max
{
    FLOAT32 fMin;
    FLOAT32 fMax;
} MIN_MAX, *PMIN_MAX, **PPMIN_MAX;


typedef struct _uv
{
    FLOAT32 u;
    FLOAT32 v;
} UV, *PUV, **PPUV;

typedef struct _uv_info
{
    UV uv[2];
} UV_INFO, *PUV_INFO, **PPUV_INFO;


// fuel_tank_selector enum values
typedef	enum	FUEL_SELECT
{
    FUEL_TANK_SELECTOR_OFF = 0,
    FUEL_TANK_SELECTOR_ALL = 1,
    FUEL_TANK_SELECTOR_LEFT = 2,
    FUEL_TANK_SELECTOR_RIGHT = 3,
    FUEL_TANK_SELECTOR_LEFT_AUX = 4,
    FUEL_TANK_SELECTOR_RIGHT_AUX = 5,
    FUEL_TANK_SELECTOR_CENTER = 6,
    FUEL_TANK_SELECTOR_CENTER2 = 7,
    FUEL_TANK_SELECTOR_CENTER3 = 8,
    FUEL_TANK_SELECTOR_EXTERNAL1 = 9,
    FUEL_TANK_SELECTOR_EXTERNAL2 = 10,
    FUEL_TANK_SELECTOR_RIGHT_TIP = 11,
    FUEL_TANK_SELECTOR_LEFT_TIP = 12,
    FUEL_TANK_SELECTOR_CROSSFEED = 13,
    FUEL_TANK_SELECTOR_CROSSFEED_L2R = 14,
    FUEL_TANK_SELECTOR_CROSSFEED_R2L = 15,
    FUEL_TANK_SELECTOR_BOTH = 16,
    FUEL_TANK_SELECTOR_EXTERNAL_ALL = 17,

    FUEL_TANK_MAXIMUM
} FUEL_SELECT, *PFUEL_SELECT, **PPFUEL_SELECT;

// cross feed enum values
typedef	enum	CROSS_FEED_SELECT
{
	CROSS_FEED_OFF = 0,
	CROSS_FEED_LEFT_TO_RIGHT,
	CROSS_FEED_RIGHT_TO_LEFT,

	CROSS_FEED_MAX
} CROSS_FEED, *PCROSS_FEED, **PPCROSS_FEED;

// prop type enum values
typedef enum PROP_TYPE
{
	PROP_TYPE_NONE,
	PROP_TYPE_FIXED,
	PROP_TYPE_MANUAL,
	PROP_TYPE_CHOICE
} PROP_TYPE;

// units enum values
typedef enum UNITS_OF_MEASURE
{
	ENGLISH_UNITS,
	METRIC_UNITS_ALT_FEET,
	METRIC_UNITS_ALT_METER
} UNITS_OF_MEASURE;

//
//	Panel System types and defines
//

//	Token list
//

typedef	enum	GAUGE_TOKEN
{
	MODULE_VAR_NONE = 0,
	TICK18,						//  inc'd at 18hz. used for general purpose timing
	GROUND_ALTITUDE,			//  ground level altitude (1/256 meter/unit)
	CLOCK_HOUR,					//  local clock time, hours {0..23}
	CLOCK_MINUTE,				//  local clock time, minutes {0..59}
	CLOCK_SECOND,				//  local clock time, seconds {0..59}
	ZULU_HOUR,					//  delta time from GMT
	ZULU_MINUTE,				//  delta time from GMT
	ZULU_DAY,					//  GMT day of year (1 - 365/366)
	ZULU_YEAR,					//  GMT year
	PANEL_LIGHTS,				//  TRUE=panel lighting on
	STROBE_LIGHTS,				//  TRUE=strobe lights on
	STROBE_FLASH,				//  TRUE=strobe flash on model & screen
	PITOT_HEAT,					//	TRUE=pitot heat on
	LANDING_LIGHTS,				//  TRUE=landing lights on
	SMOKE_ENABLE,				//  TRUE=smoke system active
	ADF_FREQUENCY,				//  |
	ADF_500_HZ_TUNABLE,			//	|	ADF frequency
	ADF_EXTENDED_FREQUENCY,		//	|
	ADF_IDENTITY,
	ADF_SIGNAL_STRENGTH,
	ADF_MORSE_IDENT,
	ADF_CARD_RADIAL,			//	integer degrees 0-360
	COM_FREQUENCY,				//  BCD COM radio freq
	NAV1_FREQUENCY,				//  BCD NAV1 radio freq
	NAV1_VOR_RADIAL,
	NAV1_MORSE_IDENT,
	NAV2_FREQUENCY,				//  BCD NAV2 radio freq
	NAV2_VOR_RADIAL,
	NAV2_MORSE_IDENT,
	DME1_DISPLAY_TYPE,			//  FALSE=distance readout,  TRUE=speed in kts readout
	DME1_DISTANCE,				//  DME1 distance readout
	DME1_SPEED,					//  DME1 speed readout
	DME1_MORSE_IDENT,
	DME2_DISPLAY_TYPE,			//  FALSE=distance readout,  TRUE=speed in kts readout
	DME2_DISTANCE,				//  DME2 distance readout
	DME2_SPEED,					//  DME2 speed readout
	DME2_MORSE_IDENT,
	TRANSPONDER_CODE,			//  Octal Transponder code {0000 - 7777}
	ADF_NEEDLE,					//	16 bit pseudodegrees
	VOR1_NEEDLE,				// +-127 correspond to +-10 if VOR or to +-2.5 if localiser.
	VOR1_GS_NEEDLE,				// +-120 correspond to +-0.7
	VOR1_BACK_COURSE_FLAGS,		//  Status of VOR1 (see BC_FLAG_ in FS6DEF.H)
	VOR1_TF_FLAG,
	VOR1_GS_FLAG,
	VOR1_OBI,
	VOR1_CODE,
	VOR1_IDENTITY,
	VOR1_MAG_VAR,
	VOR1_SIGNAL_STRENGTH,
	VOR2_NEEDLE,
	VOR2_BACK_COURSE_FLAGS,		//  Status of VOR2 (see BC_FLAG_ in FS6DEF.H)
	VOR2_TF_FLAG,
	VOR2_GS_FLAG,
	VOR2_OBI,
	VOR2_CODE,
	VOR2_IDENTITY,
	VOR2_MAG_VAR,
	VOR2_SIGNAL_STRENGTH,
	VOR2_BEARING_DEGREES,
	AIRCRAFT_ON_GROUND,			//  TRUE=aircraft is on the ground
	AIRSPEED,					//	Airspeed - Indicated or True based on GLOBALP->indicated_aspd
	AIRSPEED_TRUE_CALIBRATE,	//	Degrees rotation of the tas calibration card
	BARBER_POLE_ASPD,			//  Movable Red-line airspeed  {1/128th knot/unit}
	MACH,						//  mach, 64k=3.2 mach (would be better as UIF32)
	VERTICAL_SPEED,				//  Velocity Up, vertical speed {1/256th m/sec}
	MACH_MAX_OPERATE,
	STALL_WARNING,				//  TRUE=5 knots before stall
	OVERSPEED_WARNING,			//  TRUE=overspeed warning
	TURN_COORDINATOR_BALL_POS,	//  turn coordinator ball position {-127..0..127}
	DELTA_HEADING_RATE,
	PLANE_LATITUDE,				//  current position of our aircraft
	PLANE_LONGITUDE,			//  current position of our aircraft
	PLANE_ALTITUDE,				//  current position of our aircraft
	ALT_FROM_BAROMETRIC_PRESSURE,
	KOHLSMAN_SETTING_MB,		//  knob position millibars
	KOHLSMAN_SETTING_HG,		//  knob position inches of hg
	PLANE_PITCH_DEGREES,
	ATTITUDE_INDICATOR_PITCH_DEGREES,
	PLANE_BANK_DEGREES,
	ATTITUDE_INDICATOR_BANK_DEGREES,
	PLANE_HEADING_DEGREES_MAGNETIC,
	MAGNETIC_VAR,				//  magnetic north vs. true north angular error
	WHISKEY_COMPASS_DEGREES,	//	True degrees
	PLANE_HEADING_DEGREES_GYRO,
	GYRO_DRIFT_ERROR,
	PLANE_HEADING_DEGREES_TRUE,
	AIRCRAFT_AUTOPILOT_AVAILABLE,
	AIRCRAFT_FLAPS_AVAILABLE,
	AIRCRAFT_STALL_HORN_AVAILABLE,
	AIRCRAFT_ENGINE_MIXTURE_AVAILABLE,
	AIRCRAFT_CARB_HEAT_AVAILABLE,
	AIRCRAFT_SPOILER_AVAILABLE,
	AIRCRAFT_IS_TAIL_DRAGGER,
	AIRCRAFT_STROBES_AVAILABLE,
	AIRCRAFT_PROP_TYPE_AVAILABLE,	//  PROP_TYPE_FIXED, PROP_TYPE_MANUAL, PROP_TYPE_AUTOMATIC
	AIRCRAFT_TOE_BRAKES_AVAILABLE,
	AIRCRAFT_NAV1_AVAILABLE,
	AIRCRAFT_NAV2_AVAILABLE,
	AIRCRAFT_NAV1_OBS_AVAILABLE,
	AIRCRAFT_NAV2_OBS_AVAILABLE,
	AIRCRAFT_VOR2_GAUGE_AVAILABLE,
	AIRCRAFT_GYRO_DRIFT_AVAILABLE,	// fek: may not be used for bug #2131 but making other changes...build build build
	AUTOPILOT_ACTIVE,			//  autopilot master on/off
	AUTOPILOT_WING_LEVELER,		//  wing leveler on/off
	AUTOPILOT_NAV1_LOCK,		//  nav 1 lock on/off
	AUTOPILOT_HEADING_LOCK,		//  heading lock on/off
	AUTOPILOT_HEADING_LOCK_DIR,	//  heading lock direction
	AUTOPILOT_ALTITUDE_LOCK,	//  altitude lock on/off
	AUTOPILOT_ALTITUDE_LOCK_VAR,//  altitude lock altitude in appropriate units
	AUTOPILOT_ATTITUDE_HOLD,	//  attitude hold
	AUTOPILOT_GLIDESLOPE_HOLD,	//  glideslope hold
	AUTOPILOT_APROACH_HOLD,		//  approach hold
	AUTOPILOT_BACKCOURSE_HOLD,	//  backcourse hold
	AUTOPILOT_YAW_DAMPER,		//  yaw damper
	AUTOPILOT_AIRSPEED_HOLD,	//  airspeed hold
	AUTOPILOT_AIRSPEED_HOLD_VAR,//  airspeed hold var
	AUTOPILOT_MACH_HOLD,		//  airspeed hold
	AUTOPILOT_MACH_HOLD_VAR,	//  airspeed hold var
	AUTOPILOT_VERTICAL_HOLD, 	//  vertical hold
	AUTOPILOT_VERTICAL_HOLD_VAR,//  vertical speed hold var in appropriate units
	AUTOPILOT_ALTITUDE_MANUALLY_TUNABLE,
	AUTOPILOT_HEADING_MANUALLY_TUNABLE,
	AUTOPILOT_AUTO_THROTTLE_ARM,
	AUTOPILOT_TAKEOFF_POWER_ACTIVE,
	ENGINE_RPM_HOLD,
	ENGINE_CONTROL_SELECT,				//  which engine is being controlled
	ENGINE1,
	ENGINE1_THROTTLE_LEVER_POS,	//	throttle position			(16k = 100% throttle position)
	ENGINE1_PROPELLER_LEVER_POS,	//	propeller lever position	(16k = 100% prop setting)
	ENGINE1_MIXTURE_LEVER_POS,		//	mixture position			(16k = 100% mixture position)
	ENGINE1_COMBUSTION,			//	combustion flag				(combustion = TRUE)
	ENGINE1_STARTER_SWITCH_POS,	//	starter switch position
	ENGINE1_MAGNETO_LEFT,			//	left magneto status			(activated = 1)
	ENGINE1_MAGNETO_RIGHT,			//	right magneto status		(activated = 1)
	ENGINE1_N1_RPM,				//	gas producer (RPM)			(16k = 100% RPM)
	ENGINE1_N2_RPM,				//	power (RPM)					(16k = 100% RPM)
	ENGINE1_FF_GPH,
	ENGINE1_FF_PPH,				//	fuel flow PPH
	ENGINE1_FF_PPH_SSL,			//	fuel flow (PPH)				(16k = 100%, Standard sea level conditions)
	ENGINE1_TORQUE,				//	torque produced ( FT*LBS )
	ENGINE1_ANTI_ICE_SWITCH,		//	anti ice switch
	ENGINE1_PRESSURE_RATIO,		//	engine pressure ratio		(65k = 6.4)
	ENGINE1_PRESSURE_BUG_POS,		//	epr governed engine setting (16k = 100% epr setting)
	ENGINE1_EGT,					//	exhaust gas temp (degC)		(16k = 860 deg)
	ENGINE1_EGT_BUG_POS,			//	egt governed engine setting (16k = 100% egt setting)
	ENGINE1_CHT,					//	cylinder head temperature
	ENGINE1_OIL_TEMPERATURE,		//	oil temperature (degC)		(16k = 140 deg)
	ENGINE1_OIL_PRESSURE,			//	oil pressure (PSI)			(16k = 55 PSI)
	ENGINE1_OIL_QUANTITY,			//	oil quantity				(16k = 100%)
	ENGINE1_HYDRAULIC_PRESSURE,	//	hydraulic pressure (PSI)	(16k = 4 psi)
	ENGINE1_HYDRAULIC_QUANTITY,	//	hydraulic quantity			(16k = 100%)
	ENGINE1_MANIFOLD_PRESSURE,		//	manifold pressure			(65k = 64)
	ENGINE1_ENGINE_VIBRATION,		//	oil quantity				(16k = 5)
	ENGINE1_RPM_SCALER,			//	*16384 gives actual prop rpm in dx (= 65535 for jets)
	ENGINE1_TURBINE_TEMPERATURE,	//	(DegC * 16384)
	ENGINE1_TORQUE_PERCENT,			//	(FT/LBS * 16384)
	ENGINE1_FUEL_PRESSURE,				//	(PSI * 16384)
	ENGINE1_ELECTRICAL_LOAD,			//	(Max Load * 16384)
	ENGINE1_TRANSMISSION_PRESSURE,		//	(PSI * 16384)
	ENGINE1_TRANSMISSION_TEMPERATURE,	//	(DegC * 16384)
	ENGINE1_ROTOR_RPM,					//	(Max 8 16384)
	ENGINE2,
	ENGINE2_THROTTLE_LEVER_POS,	//	throttle position (0-16384=>0-100%throttle position)
	ENGINE2_PROPELLER_LEVER_POS,//	propeller lever position (0-16384=>0-100%prop setting)
	ENGINE2_MIXTURE_LEVER_POS,	//	mixture position (0-16384=>0-100%mixture position)
	ENGINE2_COMBUSTION,			//	combustion flag (combustion = TRUE)
	ENGINE2_STARTER_SWITCH_POS,	//	starter switch position
	ENGINE2_MAGNETO_LEFT,		//	left magneto status (activated = 1)
	ENGINE2_MAGNETO_RIGHT,		//	right magneto status (activated = 1)
	ENGINE2_N1_RPM,				//	gas producer RPM (0-16384=>0-100%RPM)
	ENGINE2_N2_RPM,				//	power RPM (0-16384=>0-100%RPM)
	ENGINE2_FF_GPH,
	ENGINE2_FF_PPH,				//	PPH
	ENGINE2_FF_PPH_SSL,			//	fuel flow (0-16384=>0-100%)PPH, Standard sea level conditions
	ENGINE2_TORQUE,				//	torque produced ( FT*LBS )
	ENGINE2_ANTI_ICE_SWITCH,	//	anti ice switch
	ENGINE2_PRESSURE_RATIO,		//	engine pressure ratio (0-65536=>0-6.4)
	ENGINE2_PRESSURE_BUG_POS,	//	epr governed engine setting (0-16384=>0-100%epr setting)
	ENGINE2_EGT,				//	exhaust gas temperature (degC)
	ENGINE2_EGT_BUG_POS,		//	egt governed engine setting (0-16384=>0-100%egt setting)
	ENGINE2_CHT,				//	cylinder head temperature
	ENGINE2_OIL_TEMPERATURE,	//	oil temperature (degC)
	ENGINE2_OIL_PRESSURE,		//	oil pressure (PSI)
	ENGINE2_OIL_QUANTITY,		//	oil quantity (0-16384 => 0-100%)
	ENGINE2_HYDRAULIC_PRESSURE,	//	hydraulic pressure (0-16384 => 0-4 psi)
	ENGINE2_HYDRAULIC_QUANTITY,	//	hydraulic quantity (0-16384 => 0-100%)
	ENGINE2_MANIFOLD_PRESSURE,	//	manifold pressure (0-65536=>0-64)
	ENGINE2_ENGINE_VIBRATION,	//	oil quantity (0-16384 => 0-5)
	ENGINE2_RPM_SCALER,			//	*16384 gives actual prop rpm in dx (= 65535 for jets)
	ENGINE2_TURBINE_TEMPERATURE,		//	(DegC * 16384)
	ENGINE2_TORQUE_PERCENT,				//	(FT/LBS * 16384)
	ENGINE2_FUEL_PRESSURE,				//	(PSI * 16384)
	ENGINE2_ELECTRICAL_LOAD,			//	(Max Load * 16384)
	ENGINE2_TRANSMISSION_PRESSURE,		//	(PSI * 16384)
	ENGINE2_TRANSMISSION_TEMPERATURE,	//	(DegC * 16384)
	ENGINE2_ROTOR_RPM,					//	(Max 8 16384)
	ENGINE3,
	ENGINE3_THROTTLE_LEVER_POS,	//	throttle position (0-16384=>0-100%throttle position)
	ENGINE3_PROPELLER_LEVER_POS,//	propeller lever position (0-16384=>0-100%prop setting)
	ENGINE3_MIXTURE_LEVER_POS,	//	mixture position (0-16384=>0-100%mixture position)
	ENGINE3_COMBUSTION,			//	combustion flag (combustion = TRUE)
	ENGINE3_STARTER_SWITCH_POS,	//	starter switch position
	ENGINE3_MAGNETO_LEFT,		//	left magneto status (activated = 1)
	ENGINE3_MAGNETO_RIGHT,		//	right magneto status (activated = 1)
	ENGINE3_N1_RPM,				//	gas producer RPM (0-16384=>0-100%RPM)
	ENGINE3_N2_RPM,				//	power RPM (0-16384=>0-100%RPM)
	ENGINE3_FF_GPH,
	ENGINE3_FF_PPH,				//	fuel flow PPH
	ENGINE3_FF_PPH_SSL,			//	fuel flow (0-16384=>0-100%)PPH, Standard sea level conditions
	ENGINE3_TORQUE,				//	torque produced ( FT*LBS )
	ENGINE3_ANTI_ICE_SWITCH,	//	anti ice switch
	ENGINE3_PRESSURE_RATIO,		//	engine pressure ratio (0-65536=>0-6.4)
	ENGINE3_PRESSURE_BUG_POS,	//	epr governed engine setting (0-16384=>0-100%epr setting)
	ENGINE3_EGT,				//	exhaust gas temperature (degC)
	ENGINE3_EGT_BUG_POS,		//	egt governed engine setting (0-16384=>0-100%egt setting)
	ENGINE3_CHT,				//	cylinder head temperature
	ENGINE3_OIL_TEMPERATURE,	//	oil temperature (degC)
	ENGINE3_OIL_PRESSURE,		//	oil pressure (PSI)
	ENGINE3_OIL_QUANTITY,		//	oil quantity (0-16384 => 0-100%)
	ENGINE3_HYDRAULIC_PRESSURE,	//	hydraulic pressure (0-16384 => 0-4 psi)
	ENGINE3_HYDRAULIC_QUANTITY,	//	hydraulic quantity (0-16384 => 0-100%)
	ENGINE3_MANIFOLD_PRESSURE,	//	manifold pressure (0-65536=>0-64)
	ENGINE3_ENGINE_VIBRATION,	//	oil quantity (0-16384 => 0-5)
	ENGINE3_RPM_SCALER,			//	*16384 gives actual prop rpm in dx (= 65535 for jets)
	ENGINE3_TURBINE_TEMPERATURE,		//	(DegC * 16384)
	ENGINE3_TORQUE_PERCENT,				//	(FT/LBS * 16384)
	ENGINE3_FUEL_PRESSURE,				//	(PSI * 16384)
	ENGINE3_ELECTRICAL_LOAD,			//	(Max Load * 16384)
	ENGINE3_TRANSMISSION_PRESSURE,		//	(PSI * 16384)
	ENGINE3_TRANSMISSION_TEMPERATURE,	//	(DegC * 16384)
	ENGINE3_ROTOR_RPM,					//	(Max 8 16384)
	ENGINE4,
	ENGINE4_THROTTLE_LEVER_POS,	//	throttle position (0-16384=>0-100%throttle position)
	ENGINE4_PROPELLER_LEVER_POS,//	propeller lever position (0-16384=>0-100%prop setting)
	ENGINE4_MIXTURE_LEVER_POS,	//	mixture position (0-16384=>0-100%mixture position)
	ENGINE4_COMBUSTION,			//	combustion flag (combustion = TRUE)
	ENGINE4_STARTER_SWITCH_POS,	//	starter switch position
	ENGINE4_MAGNETO_LEFT,		//	left magneto status (activated = 1)
	ENGINE4_MAGNETO_RIGHT,		//	right magneto status (activated = 1)
	ENGINE4_N1_RPM,				//	gas producer RPM (0-16384=>0-100%RPM)
	ENGINE4_N2_RPM,				//	power RPM (0-16384=>0-100%RPM)
	ENGINE4_FF_GPH,
	ENGINE4_FF_PPH,				//	fuel flow PPH
	ENGINE4_FF_PPH_SSL,			//	fuel flow (0-16384=>0-100%)PPH, Standard sea level conditions
	ENGINE4_TORQUE,				//	torque produced ( FT*LBS )
	ENGINE4_ANTI_ICE_SWITCH,	//	anti ice switch
	ENGINE4_PRESSURE_RATIO,		//	engine pressure ratio (0-65536=>0-6.4)
	ENGINE4_PRESSURE_BUG_POS,	//	epr governed engine setting (0-16384=>0-100%epr setting)
	ENGINE4_EGT,				//	exhaust gas temperature (degC)
	ENGINE4_EGT_BUG_POS,		//	egt governed engine setting (0-16384=>0-100%egt setting)
	ENGINE4_CHT,				//	cylinder head temperature
	ENGINE4_OIL_TEMPERATURE,	//	oil temperature (degC)
	ENGINE4_OIL_PRESSURE,		//	oil pressure (PSI)
	ENGINE4_OIL_QUANTITY,		//	oil quantity (0-16384 => 0-100%)
	ENGINE4_HYDRAULIC_PRESSURE,	//	hydraulic pressure (0-16384 => 0-4 psi)
	ENGINE4_HYDRAULIC_QUANTITY,	//	hydraulic quantity (0-16384 => 0-100%)
	ENGINE4_MANIFOLD_PRESSURE,	//	manifold pressure (0-65536=>0-64)
	ENGINE4_ENGINE_VIBRATION,	//	oil quantity (0-16384 => 0-5)
	ENGINE4_RPM_SCALER,			//	*16384 gives actual prop rpm in dx (= 65535 for jets)
	ENGINE4_TURBINE_TEMPERATURE,		//	(DegC * 16384)
	ENGINE4_TORQUE_PERCENT,				//	(FT/LBS * 16384)
	ENGINE4_FUEL_PRESSURE,				//	(PSI * 16384)
	ENGINE4_ELECTRICAL_LOAD,			//	(Max Load * 16384)
	ENGINE4_TRANSMISSION_PRESSURE,		//	(PSI * 16384)
	ENGINE4_TRANSMISSION_TEMPERATURE,	//	(DegC * 16384)
	ENGINE4_ROTOR_RPM,					//	(Max 8 16384)
	NUMBER_OF_ENGINES,			//  1=single 2=twin ...
	PROP_ADVANCE_SELECTION,		//  0=fixed 1=optimal 2=manual
	THROTTLE_LOWER_LIMIT,		//  set by sim for thrust reversers
	OIL_QUANTITY_TOTAL,			//  0..7fff (8 qt.)
	SYSTEMS_AVAILABLE,
	INSTRUMENTS_AVAILABLE,
	PP_ADF,						//  partial panel variables
	PP_AIR,
	PP_ALTIM,
	PP_ATTITUDE,
	PP_COM,
	PP_COMPASS,
	PP_ELECT,					// there is no electricity in panels circuit
	PP_ENGINE,
	PP_FUEL_IND,
	PP_HEADING,
	PP_VERT_VEL,
	PP_XPNDR,
	PP_NAV,
	PP_PITOT,
	PP_TURN_COORD,
	PP_VACUUM,
	FUEL_TANK_CENTER_LEVEL,
	FUEL_TANK_CENTER_CAPACITY,
	FUEL_TANK_LEFT_MAIN_LEVEL,
	FUEL_TANK_LEFT_MAIN_CAPACITY,
	FUEL_TANK_LEFT_AUX_LEVEL,
	FUEL_TANK_LEFT_AUX_CAPACITY,
	FUEL_TANK_LEFT_TIP_LEVEL,
	FUEL_TANK_LEFT_TIP_CAPACITY,
	FUEL_TANK_RIGHT_MAIN_LEVEL,
	FUEL_TANK_RIGHT_MAIN_CAPACITY,
	FUEL_TANK_RIGHT_AUX_LEVEL,
	FUEL_TANK_RIGHT_AUX_CAPACITY,
	FUEL_TANK_RIGHT_TIP_LEVEL,
	FUEL_TANK_RIGHT_TIP_CAPACITY,
	FUEL_QUANTITY_RIGHT,		//	Total Gallons
	FUEL_QUANTITY_LEFT,			//	Total Gallons
	FUEL_QUANTITY_CENTER,		//	Total Gallons
	FUEL_WEGHT_PER_GALLON,		//  in pounds I.F  (6 lbs/gal = 1536)
	FUEL_TANK_SELECTOR,			//  see FUEL_TANK_SELECTOR_ enum values
	CROSS_FEED_SELECTOR,		//	OFF, LEFT_TO_RIGHT, or RIGHT_TO_LEFT

	OBSOLETE_YOKE_POS_Y,		// use ELEVATOR_DEFLECTION
	OBSOLETE_YOKE_IND_Y,		// use ELEVATOR_DEFLECTION
	OBSOLETE_YOKE_POS_X,		// use AILERON_DEFLECTION
	OBSOLETE_YOKE_IND_X,		// use AILERON_DEFLECTION
	OBSOLETE_AILERON_POS,		// use AILERON_DEFLECTION
	OBSOLETE_RUDDER_PEDAL_POS,	// use RUDDER_DEFLECTION
	OBSOLETE_RUDDER_PEDAL_IND,	// use RUDDER_DEFLECTION
	OBSOLETE_RUDDER_POS,		// use RUDDER_DEFLECTION
	OBSOLETE_ELEVATOR_POS,		// use ELEVATOR_DEFLECTION
	OBSOLETE_ELEVATOR_TRIM_POS,	// use ELEVATOR_TRIM
	OBSOLETE_ELEVATOR_TRIM_IND,	// use ELEVATOR_TRIM

	BRAKES_LEFT_POS,			//  0=off 32k=full brakes
	BRAKES_RIGHT_POS,			//  0=off 32k=full brakes
	BRAKE_IND,					//  0=off 16k=full brakes
	PARKING_BRAKE_POS,			//  0=off 32k=full	parking brakes
	SPOILERS_ARMED,
	SPOILERS_HANDLE_POS,
	SPOILERS_POS_LEFT,
	SPOILERS_POS_RIGHT,
	FLAPS_HANDLE_POS,
	FLAPS_POS_LEFT,
	FLAPS_POS_RIGHT,
	GEAR_HANDLE_POS,
	GEAR_POS_NOSE,
	GEAR_POS_LEFT,
	GEAR_POS_RIGHT,
	DISPLAY_UNITS,				//  english vs. metric system
	SIM_SPEED,					//  time dilation factor for sim equations
	ZOOM_FACTOR,				//	zoom value of current window in real units
	REALISM_SENSE,
	REALISM_SYSTEMS,
	RELIABILITY_SENSE,			//  0 = unreliable - 100 = totally reliable
	AMBIENT_TEMP_DEGREES_C,		//
	AMBIENT_PRES_MBAR,			//  Millibars * 16
	AMBIENT_WIND_VEL,			//
	AMBIENT_WIND_DIR,			//
	AMBIENT_WINDE,				//  MPS x(east) wind component
	AMBIENT_WINDN,				//  MPS z(up) wind component
	AMBIENT_WINDA,				//  MPS y(north) wind component
	BAROMETRIC_PRESSURE,		//	barometric pressure experienced
	ANGLE_OF_ATTACK_INDICATOR,
	TOTAL_AIR_TEMP,
	G_FORCE,
	CHARGING_AMPS,				//  charging system amps - 1 amp=65535
	SUCTION_PRESSURE,			//	in hg
	MARKER_BEACON_STATE,		//	0=no beacon, 1=outer, 2=middle, 3=inner
	CURRENT_DME,				//  DMECUR_DME1 or DMECUR_DME2
	// **********  New VARS for Combat Flight Simulator 1.0 ***************
	PANEL_STATE_FLAGS,
	GET_GUN_AMMO,
	GET_CANNON_AMMO,
	GET_ROCKET_AMMO,
	GET_BOMB_AMMO,
	ENGINE_PRIMER,				// 0.0 -> 1.0 == in -> out
	COWL_FLAPS,					// 0.0 -> 1.0 == closed -> open
	MASTER_ALTERNATOR,			// 0.0 -> 1.0 == off -> on
	MASTER_BATTERY,				// 0.0 -> 1.0 == off -> on
	CARB_HEAT,					// 0.0 -> 1.0 == off -> on
	FLIGHT_TIME,				// in 1/10 of hours
	FUEL_PUMP,					// 0.0 -> 1.0 == off -> on
	BEACON_LIGHTS,				// 0.0 -> 1.0 == off -> on
	TAXI_LIGHTS,				// 0.0 -> 1.0 == off -> on
	RADIO_STACK_VISIBLE,		// 0.0 -> 1.0 == off -> on
	HORIZON_BAR_OFFSET,			// -10 deg to + 10 deg
	CURRENT_DME_DISTANCE,
	CURRENT_DME_SPEED,
	CURRENT_DME_MIN,
	WARNING_FUEL,
	WARNING_FUEL_L,
	WARNING_FUEL_R,
	WARNING_VACUUM,
	WARNING_VACUUM_L,
	WARNING_VACUUM_R,
	WARNING_OIL_PSI,
	WARNING_VOLTAGE,
	FUEL_TANK_CENTER2_LEVEL,
	FUEL_TANK_CENTER2_CAPACITY,
	FUEL_QUANTITY_CENTER2,                       // Total Gallons
	TOTAL_FUEL_QUANTITY_GALLONS,
	SELECTED_FUEL_QUANTITY_GALLONS,
	SELECTED_FUEL_QUANTITY_LITERS,
	SELECTED_FUEL_QUANTITY_PERCENT,
	RECIP_ENGINE1_ENGINE_RPM,
	RECIP_ENGINE1_MANIFOLD_PRESSURE,
	RECIP_ENGINE1_THROTTLE_LEVER_POS,
	RECIP_ENGINE1_MIXTURE_LEVER_POS,
	RECIP_ENGINE1_PROP_LEVER_POS,
	RECIP_ENGINE1_COWL_FLAP_POS,                //0 = closed, 1 = open
	RECIP_ENGINE1_CARB_HEAT_POS,                //0 = off, 1 = on
	RECIP_ENGINE1_ALTERNATE_AIR_POS,            //0 = closed, 1 = off
	RECIP_ENGINE1_COOLANT_RESERVOIR_PCT,
	RECIP_ENGINE1_LEFT_MAG,
	RECIP_ENGINE1_RIGHT_MAG,
	RECIP_ENGINE1_STARTER,
	RECIP_ENGINE1_BRAKE_POWER,                  //power delivered to the shaft
	RECIP_ENGINE1_SHAFT_TORQUE,                 //torque delivered to the shaft
	RECIP_ENGINE1_PROP_TORQUE,                  //torque required by prop
	RECIP_ENGINE1_STARTER_TORQUE,               //torque applied by	starter
	RECIP_ENGINE1_COMBUSTION,                   //combustion flag
	RECIP_ENGINE1_TURBOCHARGER_FAILED,
	RECIP_ENGINE1_EMERGENCY_BOOST_ACTIVE,       //like WEP in the P51
	RECIP_ENGINE1_EMERGENCY_BOOST_ELAPSED_TIME, //how long emergency has been active
	RECIP_ENGINE1_WASTEGATE_POS,                //position of wastegate controller 1=closed (full boost), 0=open (no boost)
	RECIP_ENGINE1_PROP_BETA,                    //blade angle (relative to plane of rotation)
	RECIP_ENGINE1_THRUST,                       //lbs
	RECIP_ENGINE1_EGT_DEGR,                     //EGT degrees Rankine
	RECIP_ENGINE1_TIT_DEGR,                     //Turbine Inlet Temperature degrees Rankine
	RECIP_ENGINE1_CHT_DEGR,                     //CHT degrees Rankine
	RECIP_ENGINE1_OIL_TEMP_DEGR,                //Oil Temperature degrees Rankine
	RECIP_ENGINE1_RADIATOR_DEGR,                //Radiator temperature
	RECIP_ENGINE1_OIL_PRESS_PSF,                //Oil Pressure lbs/sqft
	RECIP_ENGINE1_OIL_LEAK_PCT,                 //Percent Oil leaked
	RECIP_ENGINE1_FUEL_AVAILABLE,               //Fuel available to engine?
	RECIP_ENGINE1_FUELFLOW_PPH,                 //Fuel flow in lbs/hr
	RECIP_ENGINE1_TANK_SELECTOR,                //Fuel tank selector
	RECIP_ENGINE1_TANKS_USED,                   //Fuel tanks used
	RECIP_ENGINE1_NUMBER_OF_TANKS_USED,         //Number of fuel tanks used
	RECIP_ENGINE1_FUEL_PRESSURE_PSF,            //Fuel pressure in lbs/sqft
	RECIP_ENGINE1_COMBUSTION_SOUND_PCT,         //Percent of Sound (0 - 1)
	RECIP_ENGINE1_INDUCED_VELOCITY,             //fps, velocity induced by prop
	RECIP_ENGINE1_DAMAGE_PERCENT,               //0-100%
	RECIP_ENGINE2_ENGINE_RPM,
	RECIP_ENGINE2_MANIFOLD_PRESSURE,
	RECIP_ENGINE2_THROTTLE_LEVER_POS,
	RECIP_ENGINE2_MIXTURE_LEVER_POS,
	RECIP_ENGINE2_PROP_LEVER_POS,
	RECIP_ENGINE2_COWL_FLAP_POS,                //0 = closed, 1 = open
	RECIP_ENGINE2_CARB_HEAT_POS,                //0 = off, 1 = on
	RECIP_ENGINE2_ALTERNATE_AIR_POS,            //0 = closed, 1 = off
	RECIP_ENGINE2_COOLANT_RESERVOIR_PCT,
	RECIP_ENGINE2_LEFT_MAG,
	RECIP_ENGINE2_RIGHT_MAG,
	RECIP_ENGINE2_STARTER,
	RECIP_ENGINE2_BRAKE_POWER,                  //power delivered to the shaft
	RECIP_ENGINE2_SHAFT_TORQUE,                 //torque delivered to the shaft
	RECIP_ENGINE2_PROP_TORQUE,                  //torque required by prop
	RECIP_ENGINE2_STARTER_TORQUE,               //torque applied by	starter
	RECIP_ENGINE2_COMBUSTION,                   //combustion flag
	RECIP_ENGINE2_TURBOCHARGER_FAILED,
	RECIP_ENGINE2_EMERGENCY_BOOST_ACTIVE,       //like WEP in the P51
	RECIP_ENGINE2_EMERGENCY_BOOST_ELAPSED_TIME, //how long emergency has been active
	RECIP_ENGINE2_WASTEGATE_POS,                //position of wastegate controller 1=closed (full boost), 0=open (no boost)
	RECIP_ENGINE2_PROP_BETA,                    //blade angle (relative to plane of rotation)
	RECIP_ENGINE2_THRUST,                       //lbs
	RECIP_ENGINE2_EGT_DEGR,                     //EGT degrees Rankine
	RECIP_ENGINE2_TIT_DEGR,                     //Turbine Inlet Temperature degrees Rankine
	RECIP_ENGINE2_CHT_DEGR,                     //CHT degrees Rankine
	RECIP_ENGINE2_OIL_TEMP_DEGR,                //Oil Temperature degrees Rankine
	RECIP_ENGINE2_RADIATOR_DEGR,                //Radiator temperature
	RECIP_ENGINE2_OIL_PRESS_PSF,                //Oil Pressure lbs/sqft
	RECIP_ENGINE2_OIL_LEAK_PCT,                 //Percent Oil leaked
	RECIP_ENGINE2_FUEL_AVAILABLE,               //Fuel available to engine?
	RECIP_ENGINE2_FUELFLOW_PPH,                 //Fuel flow in lbs/hr
	RECIP_ENGINE2_TANK_SELECTOR,                //Fuel tank selector
	RECIP_ENGINE2_TANKS_USED,                   //Fuel tanks used
	RECIP_ENGINE2_NUMBER_OF_TANKS_USED,         //Number of fuel tanks used
	RECIP_ENGINE2_FUEL_PRESSURE_PSF,            //Fuel pressure in lbs/sqft
	RECIP_ENGINE2_COMBUSTION_SOUND_PCT,         //Percent of Sound (0 - 1)
	RECIP_ENGINE2_INDUCED_VELOCITY,             //fps, velocity induced by prop
	RECIP_ENGINE2_DAMAGE_PERCENT,               //0-100%
	RECIP_ENGINE3_ENGINE_RPM,
	RECIP_ENGINE3_MANIFOLD_PRESSURE,
	RECIP_ENGINE3_THROTTLE_LEVER_POS,
	RECIP_ENGINE3_MIXTURE_LEVER_POS,
	RECIP_ENGINE3_PROP_LEVER_POS,
	RECIP_ENGINE3_COWL_FLAP_POS,                //0 = closed, 1 = open
	RECIP_ENGINE3_CARB_HEAT_POS,                //0 = off, 1 = on
	RECIP_ENGINE3_ALTERNATE_AIR_POS,            //0 = closed, 1 = off
	RECIP_ENGINE3_COOLANT_RESERVOIR_PCT,
	RECIP_ENGINE3_LEFT_MAG,
	RECIP_ENGINE3_RIGHT_MAG,
	RECIP_ENGINE3_STARTER,
	RECIP_ENGINE3_BRAKE_POWER,                  //power delivered to the shaft
	RECIP_ENGINE3_SHAFT_TORQUE,                 //torque delivered to the shaft
	RECIP_ENGINE3_PROP_TORQUE,                  //torque required by prop
	RECIP_ENGINE3_STARTER_TORQUE,               //torque applied by	starter
	RECIP_ENGINE3_COMBUSTION,                   //combustion flag
	RECIP_ENGINE3_TURBOCHARGER_FAILED,
	RECIP_ENGINE3_EMERGENCY_BOOST_ACTIVE,       //like WEP in the P51
	RECIP_ENGINE3_EMERGENCY_BOOST_ELAPSED_TIME, //how long emergency has been active
	RECIP_ENGINE3_WASTEGATE_POS,                //position of wastegate controller 1=closed (full boost), 0=open (no boost)
	RECIP_ENGINE3_PROP_BETA,                    //blade angle (relative to plane of rotation)
	RECIP_ENGINE3_THRUST,                       //lbs
	RECIP_ENGINE3_EGT_DEGR,                     //EGT degrees Rankine
	RECIP_ENGINE3_TIT_DEGR,                     //Turbine Inlet Temperature degrees Rankine
	RECIP_ENGINE3_CHT_DEGR,                     //CHT degrees Rankine
	RECIP_ENGINE3_OIL_TEMP_DEGR,                //Oil Temperature degrees Rankine
	RECIP_ENGINE3_RADIATOR_DEGR,                //Radiator temperature
	RECIP_ENGINE3_OIL_PRESS_PSF,                //Oil Pressure lbs/sqft
	RECIP_ENGINE3_OIL_LEAK_PCT,                 //Percent Oil leaked
	RECIP_ENGINE3_FUEL_AVAILABLE,               //Fuel available to engine?
	RECIP_ENGINE3_FUELFLOW_PPH,                 //Fuel flow in lbs/hr
	RECIP_ENGINE3_TANK_SELECTOR,                //Fuel tank selector
	RECIP_ENGINE3_TANKS_USED,                   //Fuel tanks used
	RECIP_ENGINE3_NUMBER_OF_TANKS_USED,         //Number of fuel tanks used
	RECIP_ENGINE3_FUEL_PRESSURE_PSF,            //Fuel pressure in lbs/sqft
	RECIP_ENGINE3_COMBUSTION_SOUND_PCT,         //Percent of Sound (0 - 1)
	RECIP_ENGINE3_INDUCED_VELOCITY,             //fps, velocity induced by prop
	RECIP_ENGINE3_DAMAGE_PERCENT,               //0-100%
	RECIP_ENGINE4_ENGINE_RPM,
	RECIP_ENGINE4_MANIFOLD_PRESSURE,
	RECIP_ENGINE4_THROTTLE_LEVER_POS,
	RECIP_ENGINE4_MIXTURE_LEVER_POS,
	RECIP_ENGINE4_PROP_LEVER_POS,
	RECIP_ENGINE4_COWL_FLAP_POS,                //0 = closed, 1 = open
	RECIP_ENGINE4_CARB_HEAT_POS,                //0 = off, 1 = on
	RECIP_ENGINE4_ALTERNATE_AIR_POS,            //0 = closed, 1 = off
	RECIP_ENGINE4_COOLANT_RESERVOIR_PCT,
	RECIP_ENGINE4_LEFT_MAG,
	RECIP_ENGINE4_RIGHT_MAG,
	RECIP_ENGINE4_STARTER,
	RECIP_ENGINE4_BRAKE_POWER,                  //power delivered to the shaft
	RECIP_ENGINE4_SHAFT_TORQUE,                 //torque delivered to the shaft
	RECIP_ENGINE4_PROP_TORQUE,                  //torque required by prop
	RECIP_ENGINE4_STARTER_TORQUE,               //torque applied by	starter
	RECIP_ENGINE4_COMBUSTION,                   //combustion flag
	RECIP_ENGINE4_TURBOCHARGER_FAILED,
	RECIP_ENGINE4_EMERGENCY_BOOST_ACTIVE,       //like WEP in the P51
	RECIP_ENGINE4_EMERGENCY_BOOST_ELAPSED_TIME, //how long emergency has been active
	RECIP_ENGINE4_WASTEGATE_POS,                //position of wastegate controller 1=closed (full boost), 0=open (no boost)
	RECIP_ENGINE4_PROP_BETA,                    //blade angle (relative to plane of rotation)
	RECIP_ENGINE4_THRUST,                       //lbs
	RECIP_ENGINE4_EGT_DEGR,                     //EGT degrees Rankine
	RECIP_ENGINE4_TIT_DEGR,                     //Turbine Inlet Temperature degrees Rankine
	RECIP_ENGINE4_CHT_DEGR,                     //CHT degrees Rankine
	RECIP_ENGINE4_OIL_TEMP_DEGR,                //Oil Temperature degrees Rankine
	RECIP_ENGINE4_RADIATOR_DEGR,                //Radiator temperature
	RECIP_ENGINE4_OIL_PRESS_PSF,                //Oil Pressure lbs/sqft
	RECIP_ENGINE4_OIL_LEAK_PCT,                 //Percent Oil leaked
	RECIP_ENGINE4_FUEL_AVAILABLE,               //Fuel available to engine?
	RECIP_ENGINE4_FUELFLOW_PPH,                 //Fuel flow in lbs/hr
	RECIP_ENGINE4_TANK_SELECTOR,                //Fuel tank selector
	RECIP_ENGINE4_TANKS_USED,                   //Fuel tanks used
	RECIP_ENGINE4_NUMBER_OF_TANKS_USED,         //Number of fuel tanks used
	RECIP_ENGINE4_FUEL_PRESSURE_PSF,            //Fuel pressure in lbs/sqft
	RECIP_ENGINE4_COMBUSTION_SOUND_PCT,         //Percent of Sound (0 - 1)
	RECIP_ENGINE4_INDUCED_VELOCITY,             //fps, velocity induced by prop
	RECIP_ENGINE4_DAMAGE_PERCENT,               //0-100%
	FUEL_QUANTITY_CENTER3,                      //Total Gallons
	SCORE_STRING_QUICK_COMBAT,
	SCORE_STRING_MULTIPLAYER,
	IS_MULTIPLAYER_TEAM_COMBAT,
	// **********  New VARS for Flight Simulator 7.0 ***************
	VOR1_BEARING_DEGREES,
	FORWARD_GROUND_VELOCITY,					// in ft/sec
	SIDE_GROUND_VELOCITY,						// in ft/sec
	VERTICAL_GROUND_VELOCITY,					// in ft/sec
	NORTH_VELOCITY,								// in ft/sec
	EAST_VELOCITY,								// in ft/sec
	VERTICAL_VELOCITY,							// in ft/sec
	CLOCK_TOTAL_SECONDS,				//  local clock time, seconds since midnight
	GENERAL_ENGINE1_THROTTLE_LEVER_POS,
	GENERAL_ENGINE1_PROPELLER_LEVER_POS,
	GENERAL_ENGINE1_MIXTURE_LEVER_POS ,
	GENERAL_ENGINE1_OIL_TEMP,
	GENERAL_ENGINE1_OIL_PRES,
	GENERAL_ENGINE1_STARTER,
	GENERAL_ENGINE1_FAILURE,
	GENERAL_ENGINE1_GENERATOR_SWITCH,
	GENERAL_ENGINE1_GENERATOR_ACTIVE,
	GENERAL_ENGINE1_EGT,
	GENERAL_ENGINE2_THROTTLE_LEVER_POS,
	GENERAL_ENGINE2_PROPELLER_LEVER_POS,
	GENERAL_ENGINE2_MIXTURE_LEVER_POS ,
	GENERAL_ENGINE2_OIL_TEMP,
	GENERAL_ENGINE2_OIL_PRES,
	GENERAL_ENGINE2_STARTER ,
	GENERAL_ENGINE2_FAILURE,
	GENERAL_ENGINE2_GENERATOR_SWITCH,
	GENERAL_ENGINE2_GENERATOR_ACTIVE,
	GENERAL_ENGINE2_EGT,
	GENERAL_ENGINE3_THROTTLE_LEVER_POS,
	GENERAL_ENGINE3_PROPELLER_LEVER_POS,
	GENERAL_ENGINE3_MIXTURE_LEVER_POS ,
	GENERAL_ENGINE3_OIL_TEMP,
	GENERAL_ENGINE3_OIL_PRES,
	GENERAL_ENGINE3_STARTER ,
	GENERAL_ENGINE3_FAILURE,
	GENERAL_ENGINE3_GENERATOR_SWITCH,
	GENERAL_ENGINE3_GENERATOR_ACTIVE,
	GENERAL_ENGINE3_EGT,
	GENERAL_ENGINE4_THROTTLE_LEVER_POS,
	GENERAL_ENGINE4_PROPELLER_LEVER_POS,
	GENERAL_ENGINE4_MIXTURE_LEVER_POS ,
	GENERAL_ENGINE4_OIL_TEMP,
	GENERAL_ENGINE4_OIL_PRES,
	GENERAL_ENGINE4_STARTER ,
	GENERAL_ENGINE4_FAILURE,
	GENERAL_ENGINE4_GENERATOR_SWITCH,
	GENERAL_ENGINE4_GENERATOR_ACTIVE,
	GENERAL_ENGINE4_EGT,
	NAV1_COMMNAV_TEST,
	NAV2_COMMNAV_TEST,
	COM1_AUTOSWITCH_ON,
	NAV1_AUTOSWITCH_ON,
	COM2_AUTOSWITCH_ON,
	NAV2_AUTOSWITCH_ON,
	ELAPSED_SECONDS,
	G_FORCE_MAXIMUM,
	G_FORCE_MINIMUM,
	ENGINE_WORKING_TIME,
	ENGINE1_MAX_RPM,
	ENGINE2_MAX_RPM,
	ENGINE3_MAX_RPM,
	ENGINE4_MAX_RPM,
	ATTITUDE_BARS_POSITION,
	RAD_INS_SWITCH,		// used in concorde only
	RADIO_HEIGHT,			// meters
	DECISION_HEIGHT,		// meters
	LOW_HEIGHT_WARNING,		// boolean
	COM_STBY_FREQUENCY,		// BCD; same as COM_FREQUENCY
	COM_RADIO_25_KHZ_TUNABLE, // Boolean

	NAV_LIGHTS,
	LOGO_LIGHTS,
	WING_LIGHTS,
	RECOGNITION_LIGHTS,

	RADIO_MORSE_IDENT_STATES,


	TURB_ENGINE_1_N1,
	TURB_ENGINE_1_N2,
	TURB_ENGINE_1_CORRECTED_N1,
	TURB_ENGINE_1_CORRECTED_N2,
	TURB_ENGINE_1_CORRECTED_FF,
	TURB_ENGINE_1_PCT_MAX_TORQUE,
	TURB_ENGINE_1_EPR,
	TURB_ENGINE_1_ITT,
	TURB_ENGINE_1_AFTERBURNER,
	TURB_ENGINE_1_JET_THRUST,
	TURB_ENGINE_1_BLEEDAIRPSI,
	TURB_ENGINE_1_TANK_SELECTOR,
	TURB_ENGINE_1_TANKS_USED,
	TURB_ENGINE_1_NUMBER_TANKS,
	TURB_ENGINE_1_FUELFLOW_PPH,
	TURB_ENGINE_1_FUEL_AVAILABLE,
	TURB_ENGINE_1_PCT_AREA,
	TURB_ENGINE_1_PCT_REVERSER,
	TURB_ENGINE_1_VIBRATION,

	TURB_ENGINE_2_N1,
	TURB_ENGINE_2_N2,
	TURB_ENGINE_2_CORRECTED_N1,
	TURB_ENGINE_2_CORRECTED_N2,
	TURB_ENGINE_2_CORRECTED_FF,
	TURB_ENGINE_2_PCT_MAX_TORQUE,
	TURB_ENGINE_2_EPR,
	TURB_ENGINE_2_ITT,
	TURB_ENGINE_2_AFTERBURNER,
	TURB_ENGINE_2_JET_THRUST,
	TURB_ENGINE_2_BLEEDAIRPSI,
	TURB_ENGINE_2_TANK_SELECTOR,
	TURB_ENGINE_2_TANKS_USED,
	TURB_ENGINE_2_NUMBER_TANKS,
	TURB_ENGINE_2_FUELFLOW_PPH,
	TURB_ENGINE_2_FUEL_AVAILABLE,
	TURB_ENGINE_2_PCT_AREA,
	TURB_ENGINE_2_PCT_REVERSER,
	TURB_ENGINE_2_VIBRATION,

	TURB_ENGINE_3_N1,
	TURB_ENGINE_3_N2,
	TURB_ENGINE_3_CORRECTED_N1,
	TURB_ENGINE_3_CORRECTED_N2,
	TURB_ENGINE_3_CORRECTED_FF,
	TURB_ENGINE_3_PCT_MAX_TORQUE,
	TURB_ENGINE_3_EPR,
	TURB_ENGINE_3_ITT,
	TURB_ENGINE_3_AFTERBURNER,
	TURB_ENGINE_3_JET_THRUST,
	TURB_ENGINE_3_BLEEDAIRPSI,
	TURB_ENGINE_3_TANK_SELECTOR,
	TURB_ENGINE_3_TANKS_USED,
	TURB_ENGINE_3_NUMBER_TANKS,
	TURB_ENGINE_3_FUELFLOW_PPH,
	TURB_ENGINE_3_FUEL_AVAILABLE,
	TURB_ENGINE_3_PCT_AREA,
	TURB_ENGINE_3_PCT_REVERSER,
	TURB_ENGINE_3_VIBRATION,

	TURB_ENGINE_4_N1,
	TURB_ENGINE_4_N2,
	TURB_ENGINE_4_CORRECTED_N1,
	TURB_ENGINE_4_CORRECTED_N2,
	TURB_ENGINE_4_CORRECTED_FF,
	TURB_ENGINE_4_PCT_MAX_TORQUE,
	TURB_ENGINE_4_EPR,
	TURB_ENGINE_4_ITT,
	TURB_ENGINE_4_AFTERBURNER,
	TURB_ENGINE_4_JET_THRUST,
	TURB_ENGINE_4_BLEEDAIRPSI,
	TURB_ENGINE_4_TANK_SELECTOR,
	TURB_ENGINE_4_TANKS_USED,
	TURB_ENGINE_4_NUMBER_TANKS,
	TURB_ENGINE_4_FUELFLOW_PPH,
	TURB_ENGINE_4_FUEL_AVAILABLE,
	TURB_ENGINE_4_PCT_AREA,
	TURB_ENGINE_4_PCT_REVERSER,
	TURB_ENGINE_4_VIBRATION,

	PROPELLER_1_RPM,						// Propeller 1
	PROPELLER_1_PCT_MAX_RPM,
	PROPELLER_1_THRUST,
	PROPELLER_1_BETA,
	PROPELLER_1_FEATHERING_INHIBIT,
	PROPELLER_1_FEATHERED,
	PROPELLER_1_SYNC_DELTA_LEVER,
	PROPELLER_1_AUTOFEATHER_ARMED,

	PROPELLER_2_RPM,						// Propeller 2
	PROPELLER_2_PCT_MAX_RPM,
	PROPELLER_2_THRUST,
	PROPELLER_2_BETA,
	PROPELLER_2_FEATHERING_INHIBIT,
	PROPELLER_2_FEATHERED,
	PROPELLER_2_SYNC_DELTA_LEVER,
	PROPELLER_2_AUTOFEATHER_ARMED,

	PROPELLER_3_RPM,						// Propeller 3
	PROPELLER_3_PCT_MAX_RPM,
	PROPELLER_3_THRUST,
	PROPELLER_3_BETA,
	PROPELLER_3_FEATHERING_INHIBIT,
	PROPELLER_3_FEATHERED,
	PROPELLER_3_SYNC_DELTA_LEVER,
	PROPELLER_3_AUTOFEATHER_ARMED,

	PROPELLER_4_RPM,						// Propeller 4
	PROPELLER_4_PCT_MAX_RPM,
	PROPELLER_4_THRUST,
	PROPELLER_4_BETA,
	PROPELLER_4_FEATHERING_INHIBIT,
	PROPELLER_4_FEATHERED,
	PROPELLER_4_SYNC_DELTA_LEVER,
	PROPELLER_4_AUTOFEATHER_ARMED,

	HYDRAULICS1_PRESSURE_PSF,
	HYDRAULICS1_RESERVOIR_PCT,

	HYDRAULICS2_PRESSURE_PSF,
	HYDRAULICS2_RESERVOIR_PCT,

	HYDRAULICS3_PRESSURE_PSF,
	HYDRAULICS3_RESERVOIR_PCT,

	HYDRAULICS4_PRESSURE_PSF,
	HYDRAULICS4_RESERVOIR_PCT,

	AVIONICS_MASTER_SWITCH,

	PANEL_AUTOFEATHER_SWITCH,				// Panel States
	PANEL_ANTIICE_SWITCH,
	PANEL_AUTOBRAKE_SWITCH,

	DAY_OF_WEEK,			// 0-6
	DAY_OF_MONTH,			// 1-31
	CURRENT_MONTH,			// 1-12
	CURRENT_YEAR,			// 1-????
	TIME_ZONE_OFFSET,		// in minutes, positive west of GMT
	DAYLIGHT_SAVING_ACTIVE,	// 0 or 1

	TOTAL_LOAD_AMPS,
	BATTERY_LOAD,
	BATTERY_VOLTAGE,
	MAIN_BUS_VOLTAGE,
	MAIN_BUS_AMPS,
	AVIONICS_BUS_VOLTAGE,
	AVIONICS_BUS_AMPS,
	HOT_BATTERY_BUS_VOLTAGE,
	HOT_BATTERY_BUS_AMPS,
	BATTERY_BUS_VOLTAGE,
	BATTERY_BUS_AMPS,
	GENERATOR_ALTERNATOR_1_BUS_VOLTAGE,
	GENERATOR_ALTERNATOR_1_BUS_AMPS,
	GENERATOR_ALTERNATOR_2_BUS_VOLTAGE,
	GENERATOR_ALTERNATOR_2_BUS_AMPS,
	GENERATOR_ALTERNATOR_3_BUS_VOLTAGE,
	GENERATOR_ALTERNATOR_3_BUS_AMPS,
	GENERATOR_ALTERNATOR_4_BUS_VOLTAGE,
	GENERATOR_ALTERNATOR_4_BUS_AMPS,
	GENERAL_PANEL_CIRCUIT_ON,
	FLAP_MOTOR_CIRCUIT_ON,
	GEAR_MOTOR_CIRCUIT_ON,
	AUTOPILOT_CIRCUIT_ON,
	AVIONICS_CIRCUIT_ON,
	PITOT_HEAT_CIRCUIT_ON,
	PROP_SYNC_CIRCUIT_ON,
	AUTO_FEATHER_CIRCUIT_ON,
	AUTO_BRAKES_CIRCUIT_ON,
	STANDBY_VACUUM_CIRCUIT_ON,
	MARKER_BEACON_CIRCUIT_ON,
	GEAR_WARNING_CIRCUIT_ON,
	HYDRAULIC_PUMP_CIRCUIT_ON,
	ELEVATOR_DEFLECTION,	//	radians
	ELEVATOR_TRIM,			//	radians
	AILERON_DEFLECTION,		//	radians
	AILERON_TRIM,			//	radians
	RUDDER_DEFLECTION,		//	radians
	RUDDER_TRIM,			//	radians

	PROPSYNC_ACTIVE,

	INCIDENCE_ALPHA,
	INCIDENCE_BETA,

	TOTAL_FUEL_QUANTITY_LBS,

	FLIGHT_DIRECTOR_ACTIVE,
	FLIGHT_DIRECTOR_PITCH,		// degrees
	FLIGHT_DIRECTOR_BANK,		// degrees

	CG_PERCENT,
	CG_AFT_LIMIT,
	CG_FWD_LIMIT,
	CG_MAX_MACH,
	CG_MIN_MACH,

	STANDARD_ATM_TEMPERATURE,	// standard atmosphere temperature at aircraft's altitude; celsius

	ENGINE_1_FUELFLOW_BUG_POSITION,		// lbs per hour
	ENGINE_2_FUELFLOW_BUG_POSITION,
	ENGINE_3_FUELFLOW_BUG_POSITION,
	ENGINE_4_FUELFLOW_BUG_POSITION,

	CONCORDE_VISOR_NOSE_HANDLE,	// 0 - Visor Up, Nose Up, 1 - Visor Dn, Nose Up, 2 - Visor Dn, Nose 5 deg, 3 - Visor Dn, Nose 12.5 deg
	CONCORDE_VISOR_POS_PCT,		// 0=Up, 1.0 Extended/Down
	CONCORDE_NOSE_ANGLE,		// degrees; 0 - up

	GEAR_POS_TAIL,

	ELEVON_1_DEFLECTION,		// The elevon indices start at 1 at the far left and increase to the right.
	ELEVON_2_DEFLECTION,		// radians
	ELEVON_3_DEFLECTION,
	ELEVON_4_DEFLECTION,
	ELEVON_5_DEFLECTION,
	ELEVON_6_DEFLECTION,
	ELEVON_7_DEFLECTION,
	ELEVON_8_DEFLECTION,

	PANEL_AUTOPILOT_SPEED_SETTING,		// Knots
	AUTOPILOT_AIRSPEED_ACQUISITION,		// boolean
	AUTOPILOT_AIRSPEED_HOLD_CURRENT,	// boolean
	AUTOPILOT_MAX_SPEED,				// boolean
	AUTOPILOT_CRUISE_SPEED,				// boolean

	BARBER_POLE_MACH,					// real mach

	SELECTED_FUEL_TRANSFER_MODE,		// -1 off, 0 auto, 1 forward, 2 aft

	HYDRAULIC_SYSTEM_INTEGRITY,			// 0.0 - complete failure; 1.0 - everything is ok

	ATTITUDE_CAGE_BUTTON,

	VOR1_NEEDLE_RADIO,					// +-127 correspond to +-10 if VOR or to +-2.5 if localiser. Driven always by VOR
	GPS_POSITION_LAT,
	GPS_POSITION_LON,
	GPS_POSITION_ALT,
	GPS_MAGVAR,							// magnetic deviation (radians)
	GPS_FLAGS,							// GPS_FLAG_ACTIVE_FLIGHT_PLAN = 0x00002	there is an active flight plan
										// GPS_FLAG_ACTIVE_WAY_POINT   = 0x00004	there is an active way point
										// GPS_FLAG_ARRIVED            = 0x00008	last waypoint reached
										// GPS_FLAG_DIRECTTO_FLIGHTPLAN= 0x00020	manual flight plan
	GPS_GROUND_SPEED,					// meters per second
	GPS_GROUND_HEADING,					// radians (0 - 2PI); true heading, yaw
	GPS_GROUND_TRACK,					// radians (0 - 2PI); heading + magvar, magnetic yaw
    GPS_WP_DISTANCE,					// meters to next wp
    GPS_WP_BEARING,						// heading (radians) to next wp + magvar
    GPS_WP_CROSS_TRK,					// cross_trk (meters)
    GPS_WP_REQ_HDG,						// required heading, magnetic, radians (0 - 2PI), from prev wp to next wp
    GPS_WP_STRING,						// name of next waypoint
	GPS_WP_NEXT_LAT,
	GPS_WP_NEXT_LON,
	GPS_WP_NEXT_ALT,
	GPS_WP_PREV_LAT,
	GPS_WP_PREV_LON,
	GPS_WP_PREV_ALT,
	GPS_WP_TRUE_BEARING,				// true bearing, degrees
	GPS_WP_TRUE_REQ_HDG,				// true required heading, degrees

	GPS_DRIVES_NAV1,

	HSI_VERTICAL_NEEDLE,				// -1.0 .. 1.0 corresponds to -10deg .. 10deg if VOR or to -2.5deg .. +2.5deg if localiser +5NM .. -5NM  if GPS
	HSI_HORIZONTAL_NEEDLE,				// -1.0 .. 1.0 corresponds to -0.7deg .. +0.7deg
	HSI_VERTICAL_VALID,					// 0 - Nav flag on
	HSI_HORIZONTAL_VALID,				// 0 - GS flag on
	HSI_TF_FLAG,						// -1.0 - from. 0.0 - none, 1.0 - to
	HSI_OBI_NEEDLE,						// 0 .. 360
	HSI_DESIRED_HEADING_NEEDLE,			// 0 .. 360
	HSI_BEARING,						// 0 .. 360
	HSI_BEARING_VALID,					// 1 - true
	HSI_SIGNAL_LOCALISER,				// 1 - true
	HSI_SPEED,							// knots
	HSI_DISTANCE,						// NM
	HSI_STATION_NAME,					// string

	GEAR_POS_AUX,						//      Aux gear	0 - 16k
	TOOLTIP_UNITS,						// enum TOOLTIP_UNITS_TYPE
	LSO_TEXTURE_ID,						// current LSO_Texture_Id in AI_PLAYER.mw
	LSO_TEXT,							// text
	LEFT_FOLDING_WING_PERCENT,			// 0 - not folded; 1 - folded
	RIGHT_FOLDING_WING_PERCENT,			// 0 - not folded; 1 - folded
	MAIN_EXIT_OPEN,						// 0 - not open; 1 - open
	TAILHOOK_POSITION,				      // 0 - retracted; 1 - extended

	COM2_FREQUENCY,						// BCD same as COM_FREQUENCY
	COM2_STBY_FREQUENCY,			    // BCD; same as COM_FREQUENCY
	NAV1_STBY_FREQUENCY,			    // BCD NAV1 radio freq; same as NAV1_FREQUENCY
	NAV2_STBY_FREQUENCY,			    // BCD NAV2 radio freq; same as NAV2_FREQUENCY
	COM1_TRANSMIT_SELECT,				// 1.0 - yes
	COM2_TRANSMIT_SELECT,				// 1.0 - yes
	COM_BOTH_RECEIVE,					// 1.0 - yes
	NAV1_SOUND_TOGGLE,
	NAV2_SOUND_TOGGLE,
	DME_SOUND_TOGGLE,
	ADF_SOUND_TOGGLE,
	MARKER_SOUND_TOGGLE,
	VOR2_GS_NEEDLE,

	GENERAL_ENGINE1_ANTI_ICE_POS,	    //0 - off 1 - on
	GENERAL_ENGINE2_ANTI_ICE_POS,	    //0 - off 1 - on
	GENERAL_ENGINE3_ANTI_ICE_POS,	    //0 - off 1 - on
	GENERAL_ENGINE4_ANTI_ICE_POS,	    //0 - off 1 - on
	ENGINE1_ON_FIRE,					// 0 - no, 1 - yes
	ENGINE2_ON_FIRE,
	ENGINE3_ON_FIRE,
	ENGINE4_ON_FIRE,
	ENGINE1_FUEL_PUMP_ON,				// 0 - no, 1 - yes
	ENGINE2_FUEL_PUMP_ON,				// 0 - no, 1 - yes
	ENGINE3_FUEL_PUMP_ON,				// 0 - no, 1 - yes
	ENGINE4_FUEL_PUMP_ON,				// 0 - no, 1 - yes
	
	GENERAL_ENGINE1_FUEL_VALVE,			//1 = Open, 0 = Closed
	GENERAL_ENGINE2_FUEL_VALVE,			//1 = Open, 0 = Closed
	GENERAL_ENGINE3_FUEL_VALVE,			//1 = Open, 0 = Closed
	GENERAL_ENGINE4_FUEL_VALVE,			//1 = Open, 0 = Closed
	
	GENERAL_ENGINE1_FUEL_PRESSURE,
	GENERAL_ENGINE2_FUEL_PRESSURE,
	GENERAL_ENGINE3_FUEL_PRESSURE,
	GENERAL_ENGINE4_FUEL_PRESSURE,


	WATER_RUDDER_ON,					// 0 - up, 1 - down
	PROP_DEICE_SWITCH,					// 0 = off, 1 = on
	STRUCTURAL_DEICE_SWITCH,			// 0 = off, 1 = on 
	FUEL_TANK_SELECTOR_2,				//  see FUEL_TANK_SELECTOR_ enum values
	TRAILING_EDGE_FLAPS0_LEFT_ANGLE,	// Angle of primary trailing edge flaps
	TRAILING_EDGE_FLAPS0_RIGHT_ANGLE,	// Angle of primary trailing edge flaps

	C_GAUGE_TOKEN						// Always the last

} GAUGE_TOKEN;

	

typedef enum    VAR_TYPE {
    VAR_TYPE_NONE,		// 0

    TYPE_BOOL8,
    TYPE_UINT8,
    TYPE_SINT8,
    TYPE_FLAGS8,
    TYPE_ENUM8,

    TYPE_BOOL16,
    TYPE_ANGL16,
    TYPE_UINT16,
    TYPE_SINT16,
    TYPE_UIF16,			// 10
    TYPE_SIF16,
    TYPE_FLAGS16,
    TYPE_ENUM16,
    TYPE_BCD16,
    TYPE_BCO16,
    TYPE_VAR16,

    TYPE_BOOL32,
    TYPE_ANGL32,
    TYPE_UINT32,
    TYPE_SINT32,		// 20
    TYPE_UIF32,
    TYPE_SIF32,
    TYPE_FLAGS32,
    TYPE_ENUM32,
    TYPE_VAR32,

    TYPE_ANGL48,
    TYPE_SINT48,
    TYPE_UIF48,
    TYPE_SIF48,

    TYPE_UINT64,		// 30
    TYPE_SINT64,
    TYPE_SIF64,
    TYPE_FLOAT64,

    TYPE_BOOL,
    TYPE_FLAGS,
    TYPE_ENUM,

    TYPE_VOID,
    TYPE_PVOID,

    TYPE_PUINT32,
    TYPE_PSINT32,		// 40
    TYPE_PFLOAT64,

    VAR_TYPE_MAX
} VAR_TYPE;
	
typedef union   UNIVERSAL_VAR {
    FLOAT64 n;              // any number
    BOOL    b;              // any boolean
    ENUM    e;              // any enumerated value
    FLAGS   f;              // any flags field
    PVOID   p;              // any pointer
    VAR32   d;              // any binary coded decimal
    VAR32   o;              // any binary coded octal
} UNIVERSAL_VAR, *PUNIVERSAL_VAR, **PPUNIVERSAL_VAR;

typedef struct  MODULE_VAR {
    GAUGE_TOKEN             id;
    PVOID                   var_ptr;
    VAR_TYPE                var_type;
    UNIVERSAL_VAR           var_value;
    UNIVERSAL_VAR           var_old;                // value of global var last iteration
} MODULE_VAR, *PMODULE_VAR, **PPMODULE_VAR;
	
	
	
// Panel identifiers
#define IDENT_MAIN_PANEL						0
#define IDENT_THROTTLE_PANEL                    10
#define IDENT_RADIO_STACK_PANEL                 50
#define IDENT_COMPASS_PANEL                     75
#define IDENT_MINI_CONTROLS_PANEL               100
#define IDENT_ANNUNCIATOR_PANEL                 125
#define IDENT_ANNUNCIATOR2_PANEL                150
#define IDENT_IFR_MAIN_PANEL                    175
#define IDENT_COLLECTIVE_PANEL                  200
#define IDENT_GPS_PANEL                         225
#define IDENT_OVERHEAD_PANEL                    250
#define IDENT_USER								10000
#define IDENT_USER_MAX							19999
#define IDENT_AIRCRAFT_HUD_3D_PANEL				20000
#define IDENT_HELICOPTER_HUD_3D_PANEL			20001
#define IDENT_CONTROLS_HUD_3D_PANEL             20002
#define IDENT_TEXT_HUD_3D_PANEL                 20003
#define IDENT_DAMAGE_HUD_3D_PANEL               20004
#define IDENT_SCORE_HUD_3D_PANEL                20005
#define IDENT_LSO_WINDOW						22000
#define IDENT_INVALID                                   4294967295
	
// HUD settings
#define HUD_ON                          0x1
#define HUD_METRIC                      0x2
	
	
// PANEL STATES
//
#define PS_MAIN_PANEL_VISIBLE           BIT1
#define PS_MAIN_PANEL_COMPOSED          BIT2
#define PS_PADLOCK_SERVER				BIT3            // not used yet
#define PS_PADLOCK_CLIENT				BIT4            // not used yet
#define PS_HELICOPTER_HUD_VISIBLE       BIT5
#define PS_AIRCRAFT_HUD_VISIBLE         BIT6
#define PS_AIRCRAFT_HUD_ON				BIT7
#define PS_RADIO_STACK_VISIBLE          BIT8
#define PS_HUD_METRIC_OUTPUT            BIT9
#define PS_MAIN_PANEL_ON				BIT10
#define PS_CONTROLS_HUD_VISIBLE         BIT11
#define PS_RADIO_STACK_AUTOPOPED        BIT12
#define PS_MAIN_PANEL_UNDOCKED          BIT13
#define PS_AIRCRAFT_HUD_EXIST           BIT14
#define PS_HELICOPTER_HUD_EXIST         BIT15
#define PS_HUD_EXIST					(PS_AIRCRAFT_HUD_EXIST|PS_HELICOPTER_HUD_EXIST)
#define PS_PANELS_LOAD_VISIBLE			BIT16
#define PS_HUD_LOAD_VISIBLE				BIT17
#define PS_PANEL_VISIBLE				BIT18
#define PS_HUD_PANEL_VISIBLE			BIT19
#define PS_READONLY						 (~(PS_PADLOCK_SERVER|PS_PADLOCK_CLIENT|PS_HUD_METRIC_OUTPUT))

#define PS_SET                                          0xFFFFFFFF
#define PS_CLEAR                                        0x00000000
	
	
//
// gauge interface routines used by the panels system
//
//
// FS6.1, not used by FS7.0 gauges
typedef void FSAPI QUERY_ROUTINE( void );
typedef			   QUERY_ROUTINE           *PQUERY_ROUTINE;
	
typedef void FSAPI INSTALL_ROUTINE( PVOID resource_file_handle );
typedef			   INSTALL_ROUTINE         *PINSTALL_ROUTINE;

typedef void FSAPI INITIALIZE_ROUTINE( void );
typedef			   INITIALIZE_ROUTINE		*PINITIALIZE_ROUTINE;

typedef void FSAPI UPDATE_ROUTINE( void );
typedef			   UPDATE_ROUTINE          *PUPDATE_ROUTINE;
	
typedef enum    GENERATE_PHASE
{
        GENERATE_FX_ERASE,
        GENERATE_FX_PLOT,
        GENERATE_IMAGE_RECALC
} GENERATE_PHASE, *PGENERATE_PHASE;

typedef void FSAPI GENERATE_ROUTINE( GENERATE_PHASE phase );
typedef			   GENERATE_ROUTINE        *PGENERATE_ROUTINE;

typedef void FSAPI DRAW_ROUTINE( void );
typedef			   DRAW_ROUTINE            *PDRAW_ROUTINE;

typedef void FSAPI KILL_ROUTINE( void );
typedef			   KILL_ROUTINE            *PKILL_ROUTINE;
	
	
typedef enum {
        PANEL_TYPE_PLAIN,               //  Radio Stack
        PANEL_TYPE_HUD,                 //  Aircraft HUD
        PANEL_TYPE_SPECIAL,             //      LSO
        PANEL_TYPE_TEXTURE,             //  Virtual Cockpit Texture
} PANEL_TYPE;
	
	
typedef FLOAT64 FSAPI FN_FLOAT64      ( FLOAT64       val );
typedef               FN_FLOAT64      *PFN_FLOAT64;
	
typedef FLOAT64 FSAPI MODULE_VAR_CB   ( PMODULE_VAR   val );
typedef				  MODULE_VAR_CB   *PMODULE_VAR_CB;
	
	
// Seqsel Selection stuff
#define SELECT_NONE								0
#define SELECT_1								1
#define SELECT_ZOOM                             2
#define SELECT_MAGNETO                          3
#define SELECT_COM_WHOLE                        4
#define SELECT_COM_FRACTION                     5
#define SELECT_NAV1_WHOLE                       6
#define SELECT_NAV1_FRACTION					7
#define SELECT_NAV2_WHOLE                       8
#define SELECT_NAV2_FRACTION					9
#define SELECT_XPNDR_1000                       10
#define SELECT_XPNDR_0100                       11
#define SELECT_XPNDR_0010                       12
#define SELECT_XPNDR_0001                       13
#define SELECT_VOR1                             14
#define SELECT_VOR2                             15
#define SELECT_ENGINE                           16
#define SELECT_DME1                             17
#define SELECT_DME2                             18
#define SELECT_ADF_100                          19
#define SELECT_ADF_010                          20
#define SELECT_ADF_001                          21
#define SELECT_EGT_BUG                          22
#define SELECT_SIM_RATE                         23
#define SELECT_CLOCK_HOURS                      24
#define SELECT_CLOCK_MINUTES					25
#define SELECT_CLOCK_SECONDS					26
#define SELECT_COM2_WHOLE						27
#define SELECT_COM2_FRACTION					28
#define SELECT_ADF_TENTHS						29
	
// used for the image_flags field
#define         IMAGE_USE_TRANSPARENCY          BIT0    // these don't change dynamically and are set
#define         IMAGE_USE_ERASE                         BIT1
#define         IMAGE_USE_BRIGHT                        BIT2
#define         IMAGE_ERASE_ON_FAILURE          BIT3    // not used now
#define         IMAGE_NO_STATIC_BLENDING        BIT4    // not used now
#define         IMAGE_CREATE_DIBSECTION         BIT5
#define         IMAGE_BILINEAR_GRAY                     BIT6
#define         IMAGE_BILINEAR_COLOR            BIT7
#define         IMAGE_PRESERVE_COLOR_IN_HUD     BIT8
#define         IMAGE_CONTAINS_NO_MASK          BIT9

#define         IMAGE_SPRITE_FORCE_TRANS        BIT10   // not used now
#define         IMAGE_BLT_MASK_ONLY                     BIT11

#define         IMAGE_CONTAINS_MASK                     BIT12   // Image contains mask bits
#define         IMAGE_USE_ALPHA                         BIT13   // Image contains alpha channel
#define         IMAGE_USE_LUMINOUS                      BIT14   // Image is bright when the interior light is on
#define         IMAGE_USE_LUMINOUS_PARTIAL  BIT15       // Parts of image are lit by interior light (alpha channel)

#define         IMAGE_HIDDEN_TREE                       BIT25
#define         IMAGE_NO_STRETCH                        BIT27   // these change dynamically
#define         IMAGE_HUD_COLOR_MAP                     BIT28
#define         IMAGE_NO_TRANSLATION            BIT29
#define         IMAGE_HIDDEN                            BIT30
#define         IMAGE_ON_SCREEN                         BIT31


#define         GET_IMAGE_HIDDEN(element)                       (element->image_flags & IMAGE_HIDDEN)
#define         SHOW_IMAGE(element)                                     (element->image_flags &= ~IMAGE_HIDDEN)
#define         HIDE_IMAGE(element)                                     (element->image_flags |= IMAGE_HIDDEN)

#define         GET_IMAGE_HIDDEN_TREE(element)          (element->image_flags & IMAGE_HIDDEN_TREE)
#define         SHOW_IMAGE_TREE(element)                        (element->image_flags &= ~IMAGE_HIDDEN_TREE)
#define         HIDE_IMAGE_TREE(element)                        (element->image_flags |= IMAGE_HIDDEN_TREE)

#define         GET_USE_TRANSPARENCY( element )         (element->image_flags & IMAGE_USE_TRANSPARENCY)
#define         GET_USE_ERASE( element )                        (element->image_flags & IMAGE_USE_ERASE)
#define         GET_USE_BRIGHT( element )                       (element->image_flags & IMAGE_USE_BRIGHT)
#define         GET_ERASE_ON_FAILURE( element )         (element->image_flags & IMAGE_ERASE_ON_FAILURE)

#define         GET_ON_SCREEN( element )                        (element->image_flags & IMAGE_ON_SCREEN)
#define         SET_ON_SCREEN( element )                        element->image_flags |= IMAGE_ON_SCREEN
#define         SET_OFF_SCREEN( element )                       element->image_flags &= ~IMAGE_ON_SCREEN


#define         GET_FAILED( element )                           (element->image_flags & GAUGE_FAILURE)
#define         SET_GAUGE_FAILED( element)                      element->image_flags |= GAUGE_FAILURE
#define         SET_GAUGE_NOT_FAILED( element)          element->image_flags &= ~GAUGE_FAILURE
	
	
typedef enum ELEMENT_TYPE_ENUM {
        ELEMENT_TYPE_STATIC_IMAGE,
        ELEMENT_TYPE_NEEDLE,
        ELEMENT_TYPE_STRING,
        ELEMENT_TYPE_SLIDER,
        ELEMENT_TYPE_ICON,
        ELEMENT_TYPE_MOVING_IMAGE,
        ELEMENT_TYPE_SPRITE,
}
ELEMENT_TYPE_ENUM;
	
	
#define ASI_ALT_MANUALLY_TUNABLE                BIT0
#define ASI_HEADING_MANUALLY_TUNABLE            BIT1
	
	
typedef struct NONLINEARITY
{
        PIXPOINT        pt;
        FLOAT64         value;
        FLOAT64         degrees;
}
NONLINEARITY, *PNONLINEARITY, **PPNONLINEARITY;

typedef enum    FAILURE_KEY
{
        FAIL_NONE = 0,

        OLD_FAIL_SYSTEM_ELECTRICAL,			// obsolete: dont use it in new gauges; use FAIL_SYSTEM_ELECTRICAL_PANELS
        FAIL_SYSTEM_ENGINE,
        FAIL_SYSTEM_PITOT_STATIC,
        FAIL_SYSTEM_VACUUM,

        FAIL_GAUGE_ADF,
        FAIL_GAUGE_AIRSPEED,
        FAIL_GAUGE_ALTIMETER,
        FAIL_GAUGE_ATTITUDE,
        FAIL_GAUGE_COMMUNICATIONS,
        FAIL_GAUGE_FUEL_INDICATORS,
        FAIL_GAUGE_GYRO_HEADING,
        FAIL_GAUGE_MAGNETIC_COMPASS,
        FAIL_GAUGE_NAVIGATION,                  // this assumes no vors
        FAIL_GAUGE_NAVIGATION_VOR1,             // only vor1
        FAIL_GAUGE_NAVIGATION_VOR2,             // only vor2
        FAIL_GAUGE_NAVIGATION_BOTH,             // both vors
        FAIL_GAUGE_TRANSPONDER,
        FAIL_GAUGE_TURN_COORDINATOR,
        FAIL_GAUGE_VERTICAL_SPEED,

        FAIL_SYSTEM_ELECTRICAL_PANELS,
        FAIL_SYSTEM_ELECTRICAL_AVIONICS,

        FAIL_KEY_MAX
}
FAILURE_KEY, *PFAILURE_KEY, **PPFAILURE_KEY;
	
typedef enum    FAILURE_ACTION
{
        FAIL_ACTION_NONE = 0,
        FAIL_ACTION_FREEZE,
        FAIL_ACTION_ZERO,
        FAIL_ACTION_NO_DRAW,
        FAIL_ACTION_COVER,

        FAIL_ACTION_MAX
}
FAILURE_ACTION, *PFAILURE_ACTION, **PPFAILURE_ACTION;
	
typedef struct  FAILURE_RECORD
{
        FAILURE_KEY             key;
        FAILURE_ACTION          action;
        BOOL                    bInit;
}
FAILURE_RECORD, *PFAILURE_RECORD, **PPFAILURE_RECORD;
	
typedef struct  IMAGE_SET
{
        PIMAGE  final;
        PIMAGE  source;
        PIMAGE  reserved1;
        PIMAGE  reserved2;
} IMAGE_SET, *PIMAGE_SET, **PPIMAGE_SET;
	
	
#define PANEL_SERVICE_PRE_QUERY							0
#define PANEL_SERVICE_POST_QUERY						1
#define PANEL_SERVICE_PRE_INSTALL						2       // extra_data = resource_handle
#define PANEL_SERVICE_POST_INSTALL						3       // extra_data = resource_handle
#define PANEL_SERVICE_PRE_INITIALIZE					4
#define PANEL_SERVICE_POST_INITIALIZE					5
#define PANEL_SERVICE_PRE_UPDATE						6
#define PANEL_SERVICE_POST_UPDATE						7
#define PANEL_SERVICE_PRE_GENERATE						8       // extra_data = phase
#define PANEL_SERVICE_POST_GENERATE						9       // extra_data = phase
#define PANEL_SERVICE_PRE_DRAW							10
#define PANEL_SERVICE_POST_DRAW							11
#define PANEL_SERVICE_PRE_KILL							12
#define PANEL_SERVICE_POST_KILL							13
#define PANEL_SERVICE_CONNECT_TO_WINDOW					14      // extra_data = PANEL_WND
#define PANEL_SERVICE_DISCONNECT						15      // extra_data = PANEL_WND
#define PANEL_SERVICE_PANEL_OPEN						16
#define PANEL_SERVICE_PANEL_CLOSE						17
	
	
#define GAUGE_HEADER_VERSION_FS610						610    // FS 6.10 gauges
#define GAUGE_HEADER_VERSION_FSNEW						625    // OLD style gauges compiled in the FS70 TREE
#define GAUGE_HEADER_VERSION_CFS1						650    // CFS1 Gauges
#define GAUGE_HEADER_VERSION_FS700						700    // new FS7 gauges built after CFS1 is finalized
#define GAUGE_HEADER_VERSION_CFS2						750    // gauges built after FS2000 shipped and before CFS2 shipped
#define GAUGE_HEADER_VERSION_FS800						800    // FS2002 gauges	


typedef struct GAUGEHDR *PGAUGEHDR, **PPGAUGEHDR;
typedef struct ELEMENT_HEADER *PELEMENT_HEADER, **PPELEMENT_HEADER;
typedef struct MOUSERECT *PMOUSERECT, **PPMOUSERECT;
	
typedef void FSAPI GAUGE_CALLBACK( PGAUGEHDR pgauge, SINT32 service_id, UINT32 extra_data );
typedef            GAUGE_CALLBACK  *PGAUGE_CALLBACK;
	
typedef struct  GAUGEHDR
{
	UINT32					gauge_header_version;
	char					*gauge_name;         
	PPELEMENT_HEADER		elements_list;               
	PQUERY_ROUTINE			query_routine;               
	PINSTALL_ROUTINE		install_routine;             
	PINITIALIZE_ROUTINE		initialize_routine;          
	PUPDATE_ROUTINE			update_routine;              
	PGENERATE_ROUTINE		generate_routine;            
	PDRAW_ROUTINE			draw_routine;                
	PKILL_ROUTINE			kill_routine;                
	PVOID					reserved1;
	UINT32					size_x_mm;           
	UINT32					size_y_mm;           
	FLOAT32					x_adjust;            
	FLOAT32					y_adjust;            
	PVOID					reserved2;              
	PVOID					reserved3;   
	PIXPOINT				position;
	PVOID					reserved4;             
	PMOUSERECT				mouse_rect;          
	PGAUGE_CALLBACK         gauge_callback;              
	UINT32					user_data;           
	char*					parameters;          
	char*					usage;               
	SINT32					reserved5;
	PVOID					reserved6;
	PIXPOINT				size;                           
	FLOAT64					user_area[10];
}
GAUGEHDR;
	
	
#define ELEMENT_INFO										\
	ELEMENT_TYPE_ENUM				element_type;           \
	ID								resource_id;            \
	PIXPOINT						position;				\
	PIXPOINT						previous_position;      \
	PIXPOINT						ofs;					\
	PGAUGEHDR						gauge_header;           \
	struct ELEMENT_HEADER			*previous_element;      \
	struct ELEMENT_HEADER			**next_element;         \
	PFAILURE_RECORD					failure_systems;        \
	FLAGS							image_flags;            \
	FLAGS							aircraft_special_instrumentation;\
	FLAGS							reserved;
	
	
typedef struct ELEMENT_HEADER
{
        ELEMENT_INFO
}
ELEMENT_HEADER;
	
	
#define HEADER union		\
{							\
	struct					\
	{						\
		ELEMENT_INFO		\
	};						\
	ELEMENT_HEADER header;	\
}
	
	
typedef struct ELEMENT_STATIC_IMAGE *PELEMENT_STATIC_IMAGE,     **PPELEMENT_STATIC_IMAGE;
typedef struct ELEMENT_NEEDLE       *PELEMENT_NEEDLE,           **PPELEMENT_NEEDLE;
typedef struct ELEMENT_STRING           *PELEMENT_STRING,               **PPELEMENT_STRING;
typedef struct ELEMENT_SLIDER           *PELEMENT_SLIDER,               **PPELEMENT_SLIDER;
typedef struct ELEMENT_ICON                     *PELEMENT_ICON,                 **PPELEMENT_ICON;
typedef struct ELEMENT_MOVING_IMAGE     *PELEMENT_MOVING_IMAGE, **PPELEMENT_MOVING_IMAGE;
typedef struct ELEMENT_SPRITE           *PELEMENT_SPRITE,               **PPELEMENT_SPRITE;

typedef FLOAT64 FSAPI NEEDLE_UPDATE_CALLBACK(PELEMENT_NEEDLE pelement);
typedef               NEEDLE_UPDATE_CALLBACK                  *PNEEDLE_UPDATE_CALLBACK;

typedef FLOAT64 FSAPI STRING_UPDATE_CALLBACK(PELEMENT_STRING pelement);
typedef               STRING_UPDATE_CALLBACK                  *PSTRING_UPDATE_CALLBACK;

typedef FLOAT64 FSAPI SLIDER_UPDATE_CALLBACK(PELEMENT_SLIDER pelement);
typedef               SLIDER_UPDATE_CALLBACK                  *PSLIDER_UPDATE_CALLBACK;

typedef FLOAT64 FSAPI ICON_UPDATE_CALLBACK(PELEMENT_ICON pelement);
typedef               ICON_UPDATE_CALLBACK                    *PICON_UPDATE_CALLBACK;

typedef FLOAT64 FSAPI MOVING_IMAGE_UPDATE_CALLBACK(PELEMENT_MOVING_IMAGE pelement);
typedef               MOVING_IMAGE_UPDATE_CALLBACK    *PMOVING_IMAGE_UPDATE_CALLBACK;

typedef FLOAT64 FSAPI SPRITE_UPDATE_CALLBACK(PELEMENT_SPRITE pelement);
typedef               SPRITE_UPDATE_CALLBACK                  *PSPRITE_UPDATE_CALLBACK;
	


typedef struct ELEMENT_STATIC_IMAGE
{
	HEADER;
	IMAGE_SET               image_data;
	PIMAGE                  save_buffer;
	HDC                     hdc;                                    // HDC for Win32 API DrawText
	HBITMAP                 hbmp;                                   // DibSection for Win32 API DrawText
	HBITMAP                 reserved1;
	PIMAGE                  reserved2;
}
ELEMENT_STATIC_IMAGE, *PELEMENT_STATIC_IMAGE, **PPELEMENT_STATIC_IMAGE;
	
#define	MAKE_STATIC(	NAME,														\
						RES_ID,														\
						NEXT_LIST,													\
						FAILURE,													\
						DRAW_FLAGS,													\
						ASI_FLAGS,													\
						POSITION_X, POSITION_Y )									\
																					\
	ELEMENT_STATIC_IMAGE		NAME	=											\
	{																				\
		ELEMENT_TYPE_STATIC_IMAGE,													\
		RES_ID,																		\
		POSITION_X, POSITION_Y,														\
		{0,0},																		\
		{0,0},																		\
		&GAUGEHDR_VAR_NAME,															\
		NULL,																		\
		(PPELEMENT_HEADER)(NEXT_LIST),												\
		(PFAILURE_RECORD)(FAILURE),													\
		DRAW_FLAGS,																	\
		ASI_FLAGS,																	\
		0																			\
	};
	
	
	
typedef struct ELEMENT_NEEDLE
{
	HEADER;
	MODULE_VAR              source_var;             
	PMODULE_VAR_CB			source_var_cb;                                                              
	PFN_FLOAT64             display_value_fn;       
	PFN_FLOAT64             angle_fn;               
	PFN_FLOAT64             lag_fn;                 
	PIXPOINT                reference;              
	PNONLINEARITY			nonlinearity_table;             
	UINT32                  nonlinearity_table_size;
	SINT32                  max_degrees_per_tick;                                               
	FLOAT64                 readout_goal;                                                       
	FLOAT64                 theta_goal;                                                         
	FLOAT64                 theta;                                                              
	PIXPOINT                reference_old;                                                      
	PIXPOINT                o0, o1, o2, o3;                                                     
	IMAGE_SET               needle_data;                                                        
	PIMAGE                  texture_data;           
	UINT32                  texture_handle;                                                     
	PIMAGE                  save_buffer;            
	PIXPOINT                save_position;
	PNEEDLE_UPDATE_CALLBACK update_cb;
	PIXPOINT                save_size;
}
ELEMENT_NEEDLE, *PELEMENT_NEEDLE, **PPELEMENT_NEEDLE;

#define	MAKE_NEEDLE(	NAME,														\
						RES_ID,														\
						NEXT_LIST,													\
						FAILURE,													\
						DRAW_FLAGS,													\
						ASI_FLAGS,													\
						BKND_POSITION_X, BKND_POSITION_Y,							\
						NDL_POSITION_X, NDL_POSITION_Y,								\
						SOURCE_VAR, CALLBACK,										\
						NONLINEARITY_TABLE,											\
						MAX_DEG_PER_SEC )											\
																					\
	ELEMENT_NEEDLE				NAME	=											\
	{																				\
		ELEMENT_TYPE_NEEDLE,														\
		RES_ID,																		\
		BKND_POSITION_X, BKND_POSITION_Y,											\
		{0,0},																		\
		NDL_POSITION_X, NDL_POSITION_Y,												\
		&GAUGEHDR_VAR_NAME,															\
		NULL,																		\
		(PPELEMENT_HEADER)(NEXT_LIST),												\
		(PFAILURE_RECORD)(FAILURE),													\
		DRAW_FLAGS,																	\
		ASI_FLAGS,																	\
		0,																			\
																					\
		{SOURCE_VAR},																\
		NULL,																		\
		NULL,																		\
		NULL,																		\
		NULL,																		\
		0, 0,																		\
		NONLINEARITY_TABLE,															\
		sizeof( NONLINEARITY_TABLE )/sizeof( NONLINEARITY ),						\
		MAX_DEG_PER_SEC,															\
		0.0,																		\
		0.0,																		\
		0.0,																		\
		{0,0},																		\
		{0,0},{0,0},{0,0},{0,0},													\
		{0},																		\
		NULL,																		\
		0,																			\
		0,																			\
		{0,0},																		\
		CALLBACK,																	\
		{0,0},																		\
	};

	
	
typedef struct SEQ_REC
{
	SINT32 seq_id;
	SINT32 sel_str;
	SINT32 sel_end;
}
SEQ_REC, *PSEQ_REC, **PPSEQ_REC;

#define STR_UNSEL(ELEMENT)						((ELEMENT)->sel_end = -1, (ELEMENT)->sel_str = -1)
#define STR_SEL(ELEMENT, STR, END)				((ELEMENT)->sel_end = (END), (ELEMENT)->sel_str = (STR))
#define IS_STR_SEL(ELEMENT)						((ELEMENT)->sel_end != -1 && (ELEMENT)->sel_str != -1)
	
typedef struct ELEMENT_STRING
{
	HEADER;                                     
	MODULE_VAR              source_var[3];  
	FLOAT64                 save_var[3];    
	PMODULE_VAR_CB			source_var_cb[3];       
	PFN_FLOAT64             source_fn;      
	PCHAR                   string;         
	PCHAR                   string_old;     
	PIXPOINT                img_size;       
	PIMAGE                  string_data;    
	PIMAGE                  save_buffer;                                                
	COLORREF                fg_color;       
	COLORREF                bg_color;       
	COLORREF                hilite_color;   
	HDC						hdc;    
	HFONT                   hfont;          
	HFONT                   reserved1;      
	HBITMAP                 hbmp;           
	HBITMAP                 reserved2;       
	HBRUSH                  hbrush;         
	HBRUSH                  reserved3;     
	char                    font_name[32];  
	SINT32                  font_weight;    
	UINT8                   font_charset;   
	UINT32                  draw_text_flags;
	UINT16                  max_string_length;
	UINT16                  char_width;       
	SINT16                  sel_str;          
	SINT16                  sel_end;          
	PSEQ_REC				seq;              
	SINT32					save_global_seq;
	SINT32					char_height;
	PSTRING_UPDATE_CALLBACK update_cb;
	BOOL					use_user_color;
	COLORREF				user_color;
}
ELEMENT_STRING, *PELEMENT_STRING, **PPELEMENT_STRING;
	
#define	MAKE_STRING(	NAME,														\
						NEXT_LIST,													\
						FAILURE,													\
						DRAW_FLAGS,													\
						ASI_FLAGS,													\
						POSITION_X, POSITION_Y,										\
						SIZE_X, SIZE_Y,												\
						NUM_CHARS,													\
						SOURCE_VAR_1,												\
						SOURCE_VAR_2,												\
						SOURCE_VAR_3,												\
						FORECOLOR,													\
						BACKCOLOR,													\
						HILITECOLOR,												\
						FONT_NAME,													\
						FONT_WEIGHT,												\
						FONT_CHARSET,												\
						FONT_SIZE,													\
						DRAW_TEXT_FLAGS,											\
						HILITE_LIST,												\
						CALLBACK)													\
																					\
	ELEMENT_STRING				NAME	=											\
    {																				\
		ELEMENT_TYPE_STRING,														\
		-1,																			\
		POSITION_X, POSITION_Y,														\
		{0,0},																		\
		{0,0},																		\
		&GAUGEHDR_VAR_NAME,															\
		NULL,																		\
		(PPELEMENT_HEADER)(NEXT_LIST),												\
		(PFAILURE_RECORD)(FAILURE),													\
		DRAW_FLAGS,																	\
		ASI_FLAGS,																	\
		0,																			\
																					\
		{{SOURCE_VAR_1}, {SOURCE_VAR_2}, {SOURCE_VAR_3}},							\
		{0, 0, 0},																	\
		{NULL, NULL, NULL},															\
		NULL,																		\
		NULL,																		\
		NULL,																		\
		SIZE_X, SIZE_Y,																\
		NULL,																		\
		NULL,																		\
		FORECOLOR,																	\
		BACKCOLOR,																	\
		HILITECOLOR,																\
		0,																			\
		0,																			\
		0,																			\
		0,																			\
		0,																			\
		0,																			\
		0,																			\
		FONT_NAME,																	\
		FONT_WEIGHT,																\
		FONT_CHARSET,																\
		DRAW_TEXT_FLAGS,															\
		NUM_CHARS,																	\
		0,																			\
		0,																			\
		0,																			\
		HILITE_LIST,																\
		0,																			\
		FONT_SIZE,																	\
		CALLBACK,																	\
		FALSE,																		\
		0,																			\
	};
	
	
typedef struct ELEMENT_SLIDER
{
	HEADER;                              
	MODULE_VAR              source_var_x;
	PMODULE_VAR_CB			source_var_x_cb;     
	FLOAT64                 scale_x;     
	PFN_FLOAT64             lag_fn_x;                                             
	MODULE_VAR              source_var_y;
	PMODULE_VAR_CB			source_var_y_cb;     
	FLOAT64                 scale_y;     
	PFN_FLOAT64             lag_fn_y;    
	IMAGE_SET               slider_data; 
	PIMAGE                  save_buffer;
	PSLIDER_UPDATE_CALLBACK update_x_cb;
	PSLIDER_UPDATE_CALLBACK update_y_cb;
	FLOAT64 previous_x;
	FLOAT64 previous_y;
}
ELEMENT_SLIDER, *PELEMENT_SLIDER, **PPELEMENT_SLIDER;
	
#define	MAKE_SLIDER(	NAME,														\
						RES_ID,														\
						NEXT_LIST,													\
						FAILURE,													\
						DRAW_FLAGS,													\
						ASI_FLAGS,													\
						POSITION_X, POSITION_Y,										\
						SOURCE_VAR_X, CALLBACK_X, SCALE_X,							\
						SOURCE_VAR_Y, CALLBACK_Y, SCALE_Y )							\
																					\
	ELEMENT_SLIDER				NAME	=											\
	{																				\
		ELEMENT_TYPE_SLIDER,														\
		RES_ID,																		\
		POSITION_X, POSITION_Y,														\
		{0,0},																		\
		{0,0},																		\
		&GAUGEHDR_VAR_NAME,															\
		NULL,																		\
		(PPELEMENT_HEADER)(NEXT_LIST),												\
		(PFAILURE_RECORD)(FAILURE),													\
		DRAW_FLAGS,																	\
		ASI_FLAGS,																	\
		0,																			\
																					\
		{SOURCE_VAR_X},																\
		NULL,																		\
		SCALE_X,																	\
		NULL,																		\
		{SOURCE_VAR_Y},																\
		NULL,																		\
		SCALE_Y,																	\
		NULL,																		\
		{0},																		\
		NULL,																		\
		CALLBACK_X,																	\
		CALLBACK_Y																	\
	};
	
	
	
// Icon Switch Types
#define ICON_SWITCH_TYPE_SET_CUR_ICON					0
#define ICON_SWITCH_TYPE_SET_CUR_USING_RANGE            1
#define ICON_SWITCH_TYPE_STEP_TO						3
#define ICON_SWITCH_TYPE_STEP_TO_USING_RANGE            4
	

typedef struct ELEMENT_ICON
{
	HEADER;                                
    MODULE_VAR				source_var;    
    PMODULE_VAR_CB			source_var_cb;         
    SINT32					switch_type;   
    SINT32					switch_count;  
    FLOAT64                 scale;         
    SINT32					offset;        
    SINT32					num_icons;     
    SINT32					cur_icon;      
    SINT32					dst_icon;      
    PIMAGE_SET              picon_data;    
    PIMAGE                  save_buffer;
    PICON_UPDATE_CALLBACK	update_cb;
    ID						reserved1;
}
ELEMENT_ICON, *PELEMENT_ICON, **PPELEMENT_ICON;
	
#define	MAKE_ICON(		NAME,														\
						RES_ID,														\
						NEXT_LIST,													\
						FAILURE,													\
						DRAW_FLAGS,													\
						ASI_FLAGS,													\
						POSITION_X, POSITION_Y,										\
						SOURCE_VAR, CALLBACK,										\
						SWITCH_TYPE,												\
						NUM_ICONS,													\
						SCALE,														\
						OFFSET )													\
																					\
    ELEMENT_ICON				NAME	=											\
    {																				\
    	ELEMENT_TYPE_ICON,															\
    	RES_ID,																		\
    	POSITION_X, POSITION_Y,														\
    	{0,0},																		\
    	{0,0},																		\
		&GAUGEHDR_VAR_NAME,															\
    	NULL,																		\
    	(PPELEMENT_HEADER)(NEXT_LIST),												\
    	(PFAILURE_RECORD)(FAILURE),													\
    	DRAW_FLAGS,																	\
    	ASI_FLAGS,																	\
    	0,																			\
																					\
		{SOURCE_VAR},																\
		NULL,																		\
		SWITCH_TYPE,																\
		0,																			\
		SCALE,																		\
		OFFSET,																		\
		NUM_ICONS,																	\
		0,																			\
		0,																			\
		NULL,																		\
		NULL,																		\
		CALLBACK,																	\
    };
	
	
	
typedef struct ELEMENT_MOVING_IMAGE
{
        HEADER;                                   
        MODULE_VAR			source_var_x;     
        PMODULE_VAR_CB		source_var_x_cb;          
        FLOAT64				min_x;            
        FLOAT64				max_x;            
        PFN_FLOAT64			lag_x;            
        MODULE_VAR			source_var_y;     
        PMODULE_VAR_CB		source_var_y_cb;          
        FLOAT64				min_y;            
        FLOAT64				max_y;            
        PFN_FLOAT64			lag_y;            
        FLOAT64				scale_x;          
        FLOAT64				scale_y;          
        FLOAT64				offset_x;         
        FLOAT64				offset_y;         
        PIXPOINT			save_position;    
        IMAGE_SET			image_data;       
        IMAGE_SET			local_mask_data;  
        PIMAGE				mask_data;        
        PIMAGE				save_buffer;
        PMOVING_IMAGE_UPDATE_CALLBACK update_x_cb;
        PMOVING_IMAGE_UPDATE_CALLBACK update_y_cb;
        FLOAT64				previous_x;
        FLOAT64				previous_y;
}
ELEMENT_MOVING_IMAGE, *PELEMENT_MOVING_IMAGE, **PPELEMENT_MOVING_IMAGE;
	
#define	MAKE_MOVING(	NAME,														\
						RES_ID,														\
						NEXT_LIST,													\
						FAILURE,													\
						DRAW_FLAGS,													\
						ASI_FLAGS,													\
						POSITION_X, POSITION_Y,										\
						SOURCE_VAR_X, CALLBACK_X,									\
						MIN_X, MAX_X,												\
						SOURCE_VAR_Y, CALLBACK_Y,									\
						MIN_Y, MAX_Y )												\
																					\
	ELEMENT_MOVING_IMAGE		NAME	=											\
	{																				\
		ELEMENT_TYPE_MOVING_IMAGE,													\
		RES_ID,																		\
		POSITION_X, POSITION_Y,														\
		{0,0},																		\
		{0,0},																		\
		&GAUGEHDR_VAR_NAME,															\
		NULL,																		\
		(PPELEMENT_HEADER)(NEXT_LIST),												\
		(PFAILURE_RECORD)(FAILURE),													\
		DRAW_FLAGS,																	\
		ASI_FLAGS,																	\
		0,																			\
																					\
		{SOURCE_VAR_X},																\
		NULL,																		\
		MIN_X,																		\
		MAX_X,																		\
		NULL,																		\
		{SOURCE_VAR_Y},																\
		NULL,																		\
		MIN_Y,																		\
		MAX_Y,																		\
		NULL,																		\
		0.0,																		\
		0.0,																		\
		0.0,																		\
		0.0,																		\
		{0,0},																		\
		{0},																		\
		{0},																		\
		NULL,																		\
		NULL,																		\
		CALLBACK_X,																	\
		CALLBACK_Y																	\
	};
	
	
	
typedef struct ELEMENT_SPRITE
{
	HEADER;
	MODULE_VAR              source_var_x;      
	PMODULE_VAR_CB			source_var_x_cb;           
	FLOAT64                 scale_x;           
	MODULE_VAR              source_var_y;      
	PMODULE_VAR_CB			source_var_y_cb;           
	FLOAT64                 scale_y;           
	MODULE_VAR              source_var_0;      
	PMODULE_VAR_CB			source_var_0_cb;           
	FLOAT64                 scale_0;           
	FLOAT32					texture_scale_x; 
	FLOAT32					texture_scale_y; 
	PIXPOINT                reference;         
	PIXPOINT                reference_old;     
	PIXPOINT                o0, o1, o2, o3;    
	PIXPOINT                os0, os1, os2, os3;
	IMAGE_SET               sprite_data;       
	PIMAGE                  texture_data;      
	UINT32                  texture_handle;    
	IMAGE_SET               local_mask_data;   
	PIMAGE                  mask_data;         
	PIMAGE                  save_buffer;
	PSPRITE_UPDATE_CALLBACK update_x_cb;
	PSPRITE_UPDATE_CALLBACK update_y_cb;
	PSPRITE_UPDATE_CALLBACK update_0_cb;
	FLOAT64					previous_x;
	FLOAT64					previous_y;
	FLOAT64					previous_0;
}
ELEMENT_SPRITE, *PELEMENT_SPRITE, **PPELEMENT_SPRITE;

#define	MAKE_SPRITE(	NAME,														\
						RES_ID,														\
						NEXT_LIST,													\
						FAILURE,													\
						DRAW_FLAGS,													\
						ASI_FLAGS,													\
						BKND_POSITION_X, BKND_POSITION_Y,							\
						TEXTURE_CENTER_X, TEXTURE_CENTER_Y,							\
						TEXTURE_SCALE_X, TEXTURE_SCALE_Y,							\
						SOURCE_VAR_X, CALLBACK_X, SCALE_X,							\
						SOURCE_VAR_Y, CALLBACK_Y, SCALE_Y,							\
						SOURCE_VAR_0, CALLBACK_0, SCALE_0 )							\
																					\
	ELEMENT_SPRITE				NAME	=											\
	{																				\
		ELEMENT_TYPE_SPRITE,														\
		RES_ID,																		\
		{BKND_POSITION_X, BKND_POSITION_Y},											\
		{0,0},																		\
		{TEXTURE_CENTER_X, TEXTURE_CENTER_Y},										\
		&GAUGEHDR_VAR_NAME,															\
		NULL,																		\
		(PPELEMENT_HEADER)(NEXT_LIST),												\
		(PFAILURE_RECORD)(FAILURE),													\
		DRAW_FLAGS,																	\
		ASI_FLAGS,																	\
		0,																			\
																					\
		{SOURCE_VAR_X},																\
		NULL,																		\
		SCALE_X,																	\
		{SOURCE_VAR_Y},																\
		NULL,																		\
		SCALE_Y,																	\
		{SOURCE_VAR_0},																\
		NULL,																		\
		SCALE_0,																	\
		(FLOAT32)TEXTURE_SCALE_X, (FLOAT32)TEXTURE_SCALE_Y,							\
		{0,0},																		\
		{0,0},																		\
		{0,0},{0,0},{0,0},{0,0},													\
		{0,0},{0,0},{0,0},{0,0},													\
		{0},																		\
		NULL,																		\
		0,																			\
		{0},																		\
		NULL,																		\
		NULL,																		\
		CALLBACK_X,																	\
		CALLBACK_Y,																	\
		CALLBACK_0																	\
	};



// defines for mouse sense rect stuff
typedef	enum
{
	MOUSE_RECT_EOL,
	MOUSE_RECT_PARENT,
	MOUSE_RECT_CHILD,
	MOUSE_RECT_END_PARENT,
	MOUSE_RECT_USER,
} MOUSE_RECT_TYPE;

typedef	enum
{
	CURSOR_NONE = -1,
	CURSOR_NORMAL = 0,
	CURSOR_UPARROW,
	CURSOR_DOWNARROW,
	CURSOR_LEFTARROW,
	CURSOR_RIGHTARROW,
	CURSOR_HAND,
	CURSOR_CROSSHAIR,
} CURSOR_TYPE;
	

typedef struct	MOUSECALLBACK
{
	PIXPOINT	relative_point;
	PVOID		user_data;
	PMOUSERECT	mouse;
} MOUSECALLBACK, *PMOUSECALLBACK, **PPMOUSECALLBACK;

// arg1 is actually pointer to MOUSECALLBACK, but for compatibility is defined here as a pointer to PIXPOINT
typedef	BOOL FSAPI	MOUSE_FUNCTION( PPIXPOINT arg1, FLAGS32 mouse_flags );		
typedef				MOUSE_FUNCTION		*PMOUSE_FUNCTION;

#define GAUGEHDR_FOR_MOUSE_CALLBACK(PIXPOINT) ((PGAUGEHDR)(((PMOUSECALLBACK)(PIXPOINT))->user_data))

typedef	struct	MOUSERECT
{
	MOUSE_RECT_TYPE	rect_type;			// type of mouse rectangle (parent, child, eol)
	PIXBOX			relative_box;		// relative sense rectangle (relative to parameter to register function)
	CURSOR_TYPE		cursor;				// cursor to display when over this window
	ID				help_id;			// pop-up help id
	FLAGS			mouse_flags;		// types of mouse activities to look for
	ID				event_id;			// event to generate if mouse_flags is satisfied (implies simple mouse_flags)
	PMOUSE_FUNCTION	mouse_function;		// function to call if mouse_flag is satisfied
	PVOID			api_data;			// data for FS6API's use
} MOUSERECT;


#define	HELP_NONE			0

// Mouse rectangle macros

#define MOUSE_RIGHTSINGLE	BIT31
#define MOUSE_MIDDLESINGLE	BIT30
#define MOUSE_LEFTSINGLE	BIT29
#define MOUSE_RIGHTDOUBLE	BIT28
#define MOUSE_MIDDLEDOUBLE	BIT27
#define MOUSE_LEFTDOUBLE	BIT26
#define MOUSE_RIGHTDRAG 	BIT25
#define MOUSE_MIDDLEDRAG	BIT24
#define MOUSE_LEFTDRAG		BIT23
#define MOUSE_MOVE			BIT22
#define MOUSE_DOWN_REPEAT	BIT21
#define MOUSE_RIGHTRELEASE	BIT19
#define MOUSE_MIDDLERELEASE BIT18
#define MOUSE_LEFTRELEASE	BIT17
#define MOUSE_WHEEL_FLIP	BIT16	// invert direction of mouse wheel
#define MOUSE_WHEEL_SKIP	BIT15

#define	MOUSE_NONE			0

#define	MOUSE_PARENT_BEGIN( x, y, w, h, helpid )						{MOUSE_RECT_PARENT, {x, y, w, h}, CURSOR_NONE, helpid, MOUSE_NONE, 0, NULL, NULL},

#define	MOUSE_PARENT_END												{MOUSE_RECT_END_PARENT, {0, 0, 0, 0}, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL},

#define	MOUSE_PARENT( x, y, w, h, helpid )								MOUSE_PARENT_BEGIN( x, y, w, h, helpid )					\
																		MOUSE_PARENT_END

#define	MOUSE_BEGIN( name, helpid, x, y )								MOUSERECT	name[]	= {										\
																		MOUSE_PARENT_BEGIN( x, y, 0, 0, helpid )

#define	MOUSE_END														MOUSE_PARENT_END											\
																		{MOUSE_RECT_EOL, {0, 0, 0, 0}, CURSOR_NONE, HELP_NONE, MOUSE_NONE, 0, NULL, NULL}};

#define	MOUSE_CHILD_EVENT( x, y, w, h, cursor, mouse_flags, event_id )	{MOUSE_RECT_CHILD, {x, y, w, h}, cursor, HELP_NONE, mouse_flags, event_id, NULL, NULL},
#define	MOUSE_CHILD_FUNCT( x, y, w, h, cursor, mouse_flags, function )	{MOUSE_RECT_CHILD, {x, y, w, h}, cursor, HELP_NONE, mouse_flags, 0, function, NULL},




	
// Dynamic tooltips' stuff

#define MOUSE_TOOLTIP_TEXT_MACRO(HELPID, HELPID_METRIC, HELPID_US, STRING, ARGS, NARG)	\
										{MOUSE_RECT_USER, {0, 0, (HELPID_METRIC), (HELPID_US)}, CURSOR_NONE, (HELPID), MOUSE_NONE, (ID)(NARG), (BOOL (FSAPI *)(PPIXPOINT , FLAGS32))(STRING), (ARGS)}
#define MOUSE_TOOLTIP_TEXT(HELPID, HELPID_METRIC, HELPID_US, STRING, ARGS, NARG)	MOUSE_TOOLTIP_TEXT_MACRO(HELPID, HELPID_METRIC, HELPID_US, STRING, ARGS, NARG),
#define MOUSE_TOOLTIP_TEXT_3ID_NARG(HELPID, HELPID_METRIC, HELPID_US, ARGS, NARG)	MOUSE_TOOLTIP_TEXT (HELPID, HELPID_METRIC, HELPID_US, NULL, ARGS, NARG)
#define MOUSE_TOOLTIP_TEXT_ID_NARG(HELPID, ARGS, NARG)								MOUSE_TOOLTIP_TEXT_3ID_NARG ((HELPID), HELP_NONE, HELP_NONE, (ARGS), (NARG))
#define MOUSE_TOOLTIP_TEXT_STRING_NARG(STRING, ARGS, NARG)							MOUSE_TOOLTIP_TEXT (HELP_NONE, HELP_NONE, HELP_NONE, STRING, ARGS, NARG)
#define MOUSE_TOOLTIP_TEXT_ID(HELPID, ARGS)											MOUSE_TOOLTIP_TEXT_ID_NARG ((HELPID), (ARGS), sizeof(ARGS)/sizeof(MOUSE_ARG))
#define MOUSE_TOOLTIP_TEXT_STRING(STRING, ARGS)										MOUSE_TOOLTIP_TEXT_STRING_NARG ((STRING), (ARGS), sizeof(ARGS)/sizeof(MOUSE_ARG))
#define MOUSE_TOOLTIP_STRING(STRING)												MOUSE_TOOLTIP_TEXT_STRING_NARG ((STRING), NULL, 0)
#define MOUSE_TOOLTIP_ID(HELPID)													MOUSE_TOOLTIP_TEXT_ID_NARG ((HELPID), NULL, 0)
#define MOUSE_TOOLTIP_3ID(HELPID, HELPID_METRIC, HELPID_US)							MOUSE_TOOLTIP_TEXT_3ID_NARG ((HELPID), (HELPID_METRIC), (HELPID_US), NULL, 0)
#define MOUSE_TOOLTIP_STANDARD_STRING(STRING)										MOUSE_TOOLTIP_TEXT_STRING (STRING, 0)

#define MAKE_MOUSE_TOOLTIP_STANDARD_STRING(PARAMETER, UNITS)						"@" ## #PARAMETER ## "@" ## #UNITS
#define MOUSE_TOOLTIP_STANDARD(PARAMETER, UNITS)									MOUSE_TOOLTIP_STANDARD_STRING (MAKE_MOUSE_TOOLTIP_STANDARD_STRING (PARAMETER, UNITS))
	
	
typedef struct {
        FLOAT64 source;
        FLOAT64 value;
} MOUSE_ARG_NUMERIC_MAP;
typedef struct {
        SINT32 source;
        ID value;
} MOUSE_ARG_ID_MAP;
typedef struct {
        SINT32 source;
        PSTRINGZ value;
} MOUSE_ARG_STRING_MAP;

typedef struct {
        MODULE_VAR		source_var;
        FLOAT64			scale;
        MOUSE_ARG_NUMERIC_MAP *numeric_table;
        UINT			numeric_table_size;
        MOUSE_ARG_ID_MAP *id_table;
        UINT			id_table_size;
        MOUSE_ARG_STRING_MAP *string_table;
        UINT			string_table_size;
        FLOAT64			(FSAPI *numeric_callback) (FLOAT64 number, ID id, PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge);
        ID				(FSAPI *id_callback) (FLOAT64 number, ID id, PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge);
        PCSTRINGZ		(FSAPI *string_callback) (FLOAT64 number, ID id, PCSTRINGZ string, MODULE_VAR *source_var, PGAUGEHDR gauge);
} MOUSE_ARG;

#define MOUSE_TOOLTIP_ARGS(NAME)        MOUSE_ARG (NAME)[] = {
#define MOUSE_TOOLTIP_ARG(VAR, SCALE, NUMERIC_TABLE, ID_TABLE, STRING_TABLE, NUMERIC_CALLBACK, ID_CALLBACK, STRING_CALLBACK) \
                {{(VAR)}, (SCALE), \
                 (NUMERIC_TABLE), sizeof(NUMERIC_TABLE)/sizeof(MOUSE_ARG_NUMERIC_MAP), \
                 (ID_TABLE), sizeof(ID_TABLE)/sizeof(MOUSE_ARG_ID_MAP), \
                 (STRING_TABLE), sizeof(STRING_TABLE)/sizeof(MOUSE_ARG_STRING_MAP), \
                 (NUMERIC_CALLBACK), (ID_CALLBACK), (STRING_CALLBACK)},
#define MOUSE_TOOLTIP_ARG_NUMBER(VAR, SCALE) MOUSE_TOOLTIP_ARG((VAR), (SCALE), NULL, NULL, NULL, NULL, NULL, NULL)
#define MOUSE_TOOLTIP_ARG_HELP_ID(VAR, ID_TABLE) MOUSE_TOOLTIP_ARG((VAR), 1, NULL, (ID_TABLE), NULL, NULL, NULL, NULL)
#define MOUSE_TOOLTIP_ARG_NUMBER_FUNCT(VAR, FUNCT) MOUSE_TOOLTIP_ARG((VAR), 1, NULL, NULL, NULL, (FUNCT), NULL, NULL)
#define MOUSE_TOOLTIP_ARG_HELP_ID_FUNCT(VAR, FUNCT) MOUSE_TOOLTIP_ARG((VAR), 1, NULL, NULL, NULL, NULL, (FUNCT), NULL)
#define MOUSE_TOOLTIP_ARGS_END          };
	

#define FS8LINK_VERSION 	0x0800


#define FSLINKAGE		ID			ModuleID;						\
						void		(FSAPI *ModuleInit)(void);		\
						void		(FSAPI *ModuleDeinit)(void);	\
						FLAGS32		ModuleFlags;					\
						UINT32		ModulePriority;					\
						UINT32		ModuleVersion;

// Module Export Structure
typedef	struct	PANELS
{
	FSLINKAGE
	void   		(FSAPI *reserved1) ( void);	
	void   		(FSAPI *reserved2) ( void);	
	void   		(FSAPI *reserved3) ( void);	
	void   		(FSAPI *reserved4) ( void);	
	void   		(FSAPI *reserved5) ( void);	
	void   		(FSAPI *reserved6) ( void);	
	ENUM   		(FSAPI *tooltip_units_getset) (int action, ENUM type);	// action < 0 - toggle(ignore 'type'), = 0 get(ignore 'type'), > 0 set(use 'type')
	void   		(FSAPI *reserved7) ( void);	
	void   		(FSAPI *reserved8) ( void);	
	void   		(FSAPI *reserved9) ( void);	
	void   		(FSAPI *reserved10) ( void);	
	void   		(FSAPI *reserved11) ( void);	
	void   		(FSAPI *reserved12) ( void);	
	void   		(FSAPI *reserved13) ( void);	
	void   		(FSAPI *reserved14) ( void);	
	void   		(FSAPI *reserved15) ( void);	
	void   		(FSAPI *reserved16) ( void);	
	void   		(FSAPI *reserved17) ( void);	
	void   		(FSAPI *element_list_query) ( PELEMENT_HEADER element );	
	void   		(FSAPI *element_list_install) ( PELEMENT_HEADER element, PVOID resource_file_handle );	
	void   		(FSAPI *element_list_initialize) ( PELEMENT_HEADER element );	
	void   		(FSAPI *element_list_update) ( PELEMENT_HEADER element );	
	void   		(FSAPI *element_list_generate) ( PELEMENT_HEADER element, GENERATE_PHASE phase );	
	void   		(FSAPI *element_list_plot) ( PELEMENT_HEADER element );	
	void   		(FSAPI *element_list_erase) ( PELEMENT_HEADER element );	
	void   		(FSAPI *element_list_kill) ( PELEMENT_HEADER element );	
	void   		(FSAPI *mouse_list_install) ( PMOUSERECT rect, PGAUGEHDR gauge_header, PPIXPOINT size );	
	void   		(FSAPI *mouse_list_register) ( PMOUSERECT rect, PGAUGEHDR gauge_header );	
	void   		(FSAPI *mouse_list_unregister) ( PMOUSERECT rect, PGAUGEHDR gauge_header );	
	BOOL   		(FSAPI *panel_window_toggle) (UINT32 panel_id);	
	ERR         (FSAPI *trigger_key_event) ( ID32 event_id, UINT32 value );	
	void   		(FSAPI *register_var_by_name) ( PVOID var, VAR_TYPE var_type, PSTRINGZ name );	
	void   		(FSAPI *initialize_var) ( PMODULE_VAR module_var );	
	void   		(FSAPI *initialize_var_by_name) ( PMODULE_VAR module_var, PSTRINGZ name );	
	void   		(FSAPI *lookup_var) ( PMODULE_VAR module_var );	
	void   		(FSAPI *unregister_var_by_name) ( PSTRINGZ name );	
	void   		(FSAPI *unregister_all_named_vars) ( void );	
	void   		(FSAPI *reserved18) ( void);	
	void   		(FSAPI *reserved19) ( void);	
	BOOL   		(FSAPI *panel_window_close_ident) (UINT32 panel_id);	
	BOOL   		(FSAPI *panel_window_open_ident) (UINT32 panel_id);	
	void   		(FSAPI *panel_window_toggle_hud_color) (void);	
	void   		(FSAPI *panel_window_toggle_hud_units) (void);	
	void   		(FSAPI *radio_stack_popup) (void);	
	void   		(FSAPI *radio_stack_autoclose) (void);	
	void   		(FSAPI *reserved20) ( void);	
	void   		(FSAPI *reserved21) ( void);	
	void   		(FSAPI *reserved22) ( void);	
	void   		(FSAPI *reserved23) ( void);	
	void   		(FSAPI *reserved24) ( void);	
	void   		(FSAPI *reserved25) ( void);	
	void   		(FSAPI *reserved26) ( void);	
	void   		(FSAPI *reserved27) ( void);	
	void   		(FSAPI *reserved28) ( void);	
	void   		(FSAPI *reserved29) ( void);	
	PCSTRINGZ	(FSAPI *panel_resource_string_get) (ID32 id);	
	BOOL   		(FSAPI *panel_window_toggle_menu_id) (ID32 menu_id);	
	void   		(FSAPI *reserved30) ( void);	
	void   		(FSAPI *reserved31) ( void);	
	void   		(FSAPI *element_use_color) (PELEMENT_HEADER element, BOOL override, UINT32 color);	// color actually is  COLORREF
} PANELS, *PPANELS, **PPPANELS;


#define	element_list_query	(ImportTable.PANELSentry.fnptr->element_list_query)
#define	element_list_install	(ImportTable.PANELSentry.fnptr->element_list_install)
#define	element_list_initialize	(ImportTable.PANELSentry.fnptr->element_list_initialize)
#define	element_list_update	(ImportTable.PANELSentry.fnptr->element_list_update)
#define	element_list_generate	(ImportTable.PANELSentry.fnptr->element_list_generate)
#define	element_list_plot	(ImportTable.PANELSentry.fnptr->element_list_plot)
#define	element_list_erase	(ImportTable.PANELSentry.fnptr->element_list_erase)
#define	element_list_kill	(ImportTable.PANELSentry.fnptr->element_list_kill)
#define	mouse_list_install	(ImportTable.PANELSentry.fnptr->mouse_list_install)
#define	mouse_list_register	(ImportTable.PANELSentry.fnptr->mouse_list_register)
#define	mouse_list_unregister	(ImportTable.PANELSentry.fnptr->mouse_list_unregister)
#define	panel_window_toggle	(ImportTable.PANELSentry.fnptr->panel_window_toggle)
#define	trigger_key_event	(ImportTable.PANELSentry.fnptr->trigger_key_event)
#define	register_var_by_name	(ImportTable.PANELSentry.fnptr->register_var_by_name)
#define	initialize_var	(ImportTable.PANELSentry.fnptr->initialize_var)
#define	initialize_var_by_name	(ImportTable.PANELSentry.fnptr->initialize_var_by_name)
#define	lookup_var	(ImportTable.PANELSentry.fnptr->lookup_var)
#define	unregister_var_by_name	(ImportTable.PANELSentry.fnptr->unregister_var_by_name)
#define	unregister_all_named_vars	(ImportTable.PANELSentry.fnptr->unregister_all_named_vars)
#define	panel_window_close_ident	(ImportTable.PANELSentry.fnptr->panel_window_close_ident)
#define	panel_window_open_ident	(ImportTable.PANELSentry.fnptr->panel_window_open_ident)
#define	panel_window_toggle_hud_color	(ImportTable.PANELSentry.fnptr->panel_window_toggle_hud_color)
#define	panel_window_toggle_hud_units	(ImportTable.PANELSentry.fnptr->panel_window_toggle_hud_units)
#define	radio_stack_popup	(ImportTable.PANELSentry.fnptr->radio_stack_popup)
#define	radio_stack_autoclose	(ImportTable.PANELSentry.fnptr->radio_stack_autoclose)
#define	panel_resource_string_get	(ImportTable.PANELSentry.fnptr->panel_resource_string_get)
#define	panel_window_toggle_menu_id	(ImportTable.PANELSentry.fnptr->panel_window_toggle_menu_id)
#define	element_use_color	(ImportTable.PANELSentry.fnptr->element_use_color)


// This is the module's import table definition
typedef struct GAUGESIMPORT
{
	struct
	{
		DWORD		fnID;
		PPANELS		fnptr;
	}PANELSentry;

	struct
	{
		DWORD			fnID;
		LPVOID		fnptr;
	}dummyentry;
} GAUGESIMPORT, *PGAUGESIMPORT;

__declspec(dllexport) GAUGESIMPORT ImportTable;


// This is the module's export table definition
typedef struct  GAUGES
{
	DWORD				ModuleID;
	void			(FSAPI *ModuleInit)(void);
	void			(FSAPI *ModuleDeinit)(void);
	UINT32			ModuleFlags;
	UINT32			ModulePriority;
	UINT32			ModuleVersion;  // set to 0x0800 for FS2002 to avoid 3rd party software warning
	PVOID			DialogTable;
	PVOID		gauge_header_ptr;
} GAUGES, *PGAUGES, **PPGAUGES;

__declspec(dllexport)	GAUGES			Linkage;


// MODULE_SETUP macro to define import and export tables and gauge header
#define	MODULE_SETUP( version, size, name, element_list)		\
		extern	void FSAPI		module_init( void );			\
		extern	void FSAPI		module_deinit( void );			\
																\
		/* This is the module's export table.	*/				\
		GAUGES			Linkage =								\
		{														\
			0x0000520F,											\
			module_init,										\
			module_deinit,										\
			0,													\
			0,													\
			0x0800,												\
			0,													\
			0												    \
		};														\
																\
		/* This is the module's import table.	*/				\
		GAUGESIMPORT	ImportTable =							\
		{														\
			{ 0x0000000F, (PPANELS)NULL },						\
			{ 0x00000000, NULL }								\
		};														\


#pragma pack()

