VERSION 5.00
Begin VB.Form frmFSCDemo 
   Caption         =   "FSConnect Demo"
   ClientHeight    =   5295
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6915
   LinkTopic       =   "Form1"
   ScaleHeight     =   5295
   ScaleWidth      =   6915
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnTriggerEvent 
      Caption         =   "TriggerKeyEvent"
      Height          =   375
      Left            =   4920
      TabIndex        =   10
      Top             =   4200
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Height          =   1635
      Left            =   270
      TabIndex        =   6
      Top             =   3420
      Width           =   4335
      Begin VB.TextBox txtLat 
         Height          =   285
         Left            =   180
         TabIndex        =   3
         Top             =   1080
         Width           =   1095
      End
      Begin VB.TextBox txtLon 
         Height          =   285
         Left            =   1530
         TabIndex        =   4
         Top             =   1080
         Width           =   1095
      End
      Begin VB.CommandButton btnSetPos 
         Caption         =   "Set"
         Height          =   375
         Left            =   2970
         TabIndex        =   5
         Top             =   990
         Width           =   915
      End
      Begin VB.Label Label3 
         Caption         =   "To repostion aircraft, enter lat/lon, and click Set.  FS must be in Slew or Pause mode."
         Height          =   375
         Left            =   180
         TabIndex        =   9
         Top             =   270
         Width           =   3705
      End
      Begin VB.Label Label1 
         Caption         =   "Lat"
         Height          =   285
         Left            =   180
         TabIndex        =   8
         Top             =   810
         Width           =   465
      End
      Begin VB.Label Label2 
         Caption         =   "Lon"
         Height          =   285
         Left            =   1530
         TabIndex        =   7
         Top             =   810
         Width           =   465
      End
   End
   Begin VB.CommandButton btnClear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   4860
      TabIndex        =   2
      Top             =   990
      Width           =   1185
   End
   Begin VB.TextBox txtOutput 
      Height          =   2445
      Left            =   180
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   630
      Width           =   4515
   End
   Begin VB.CommandButton btnGetData 
      Caption         =   "Get Data"
      Height          =   375
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   1275
   End
   Begin VB.Label Label4 
      Caption         =   "Press this button to test the TriggerKeyEvent function"
      Height          =   615
      Left            =   4920
      TabIndex        =   11
      Top             =   3480
      Width           =   1815
   End
End
Attribute VB_Name = "frmFSCDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'****************************************************************
'   FSConnect SDK v1.00
'   Copyright  2003 Russel Dirks.  All rights reserved.
'   Email : russdirks@yahoo.ca
'****************************************************************
Option Explicit

Private Sub btnGetData_Click()
   Dim s As String, res, lng As Long, i
   Dim vtype As Long, lat As Double, lon As Double
   Dim v As Variant, FSVerHi As Long, FSVerLo As Long
   Dim FSCVersion As String, FSExeName As String
   Dim dataBin(1 To 100) As Byte, d As Double
   
   res = fscGetVersions(FSCVersion, FSExeName, FSVerHi, FSVerLo)
   If res <> 0 Then
      AddToOutput "Error communicating with FSConnect : " & res
      Exit Sub
   Else
      AddToOutput "FSConnect version : " & FSCVersion
      AddToOutput "Flight Sim Exe : " & FSExeName
      AddToOutput "Flight Sim Version : " & FSVerHi \ 65536 & "." & (FSVerHi And 65535) & "." & _
                 FSVerLo \ 65536 & "." & (FSVerLo And 65535)
   End If
   
   
 
   ' skip error checking from here on
   fscGetLatitude lat
   AddToOutput "Latitude: " & lat
   
   fscGetLongitude lon
   AddToOutput "Longitude: " & lon
   
   fscGetVar AIRSPEED, "n", v
   AddToOutput "Airspeed: " & v
   
   fscGetVar COM_STBY_FREQUENCY, "d", v
   AddToOutput "COM1 STBY: " & Hex(CLng(v))
   
   fscGetVar AVIONICS_MASTER_SWITCH, "b", v
   AddToOutput "AVIONICS_MASTER_SWITCH: " & IIf(v = 0, "Off", "On")
   
   fscGetString VOR1_IDENTITY, s
   AddToOutput "VOR1_IDENTITY: " & s
   
   ' ---------------------------------------------------------------------------------
   ' fscGetXMLVar examples
   ' ---------------------------------------------------------------------------------
   res = fscGetXMLVar("(A:TITLE,string)", , , s)
   AddToOutput "User Aircraft : " & s
   
   res = fscGetXMLVar("(A:PLANE ALTITUDE,feet)", d)
   AddToOutput "Altitude : " & d

   AddToOutput " "
End Sub

Sub AddToOutput(aMsg)
   Me.txtOutput.Text = Me.txtOutput.Text & aMsg & vbCrLf
   Me.txtOutput.SelStart = Len(Me.txtOutput.Text)
End Sub

Private Sub btnClear_Click()
   Me.txtOutput.Text = ""
End Sub

Private Sub btnSetPos_Click()
   Dim res
   If (Me.txtLat = "") Or (Me.txtLon = "") Then
      MsgBox "Please specify both latitude and longitude!", vbExclamation
      Exit Sub
   End If
   res = fscSetLatitude(Me.txtLat)
   If res <> 0 Then
      AddToOutput "Error communicating with FSConnect : " & res
      Exit Sub
   End If
   fscSetLongitude Me.txtLon
End Sub

Private Sub btnTriggerEvent_Click()
   Dim res
   ' sets throttle to about 50%
   res = fscTriggerKeyEvent(KEY_THROTTLE_SET, 8000)
   ' set transponder to 1234
   res = fscTriggerKeyEvent(KEY_XPNDR_SET, &H1234)
End Sub
